/*
 Open Project By Open Platform Base Team. 
 Copyright 1998 - 2012
*/
define('$', function(){
	var xTouch;
	(function(b) {
		var a = {
			extend: function(f, e, c) {
				for (var d in e) {
					f[d] = c ? e[d] : f.hasOwnProperty(d) ? f[d] : e[d]
				}
				return f
			},
			getArgType: function(d, c) {
				if (arguments.length < 1) {
					return -1
				}
				var f = typeof d;
				var e = typeof c;
				if (f === "string" && e === "undefined") {
					return 0
				}
				if (f === "object") {
					return 2
				}
				if (f === "string" && (e === "string" || e === "number")) {
					return 1
				}
				return -1
			},
			setStyle: function(e, d, c) {
				if (d.indexOf("-") !== -1) {
					d = d.replace(/\-[a-z]/g, function(f) {
						return f[1].toUpperCase()
					})
				}
				e.style[d] = c
			},
			getStyle: function(d, c) {
				c = c.replace(/[A-Z]/g, function(e) {
					return "-" + e.toLowerCase()
				});
				return document.defaultView.getComputedStyle(d, "").getPropertyValue(c)
			},
			css: function(e, d, c) {
				return a.attrHandler(e, d, c, a.getStyle, a.setStyle)
			},
			attr: function(e, d, c) {
				return a.attrHandler(e, d, c, a.handler.attrRead, a.handler.attrWrite)
			},
			handler: {
				attrRead: function(d, c) {
					return d.getAttribute(c)
				},
				attrWrite: function(e, d, c) {
					e.setAttribute(d, c)
				}
			},
			attrHandler: function(h, d, l, g, f) {
				var c = a.getArgType(d, l),
					m;
				if (c === 0) {
					m = (h.length >= 0) ? h[0] : h;
					return m ? g(m, d) : null
				}
				if (h.length >= 0) {
					for (var e = 0; e < h.length; e++) {
						m = h[e];
						if (c === 2) {
							for (var j in d) {
								f(m, j, d[j])
							}
						} else {
							f(m, d, l)
						}
					}
				} else {
					if (c === 2) {
						for (var j in d) {
							f(h, j, d[j])
						}
					} else {
						f(h, d, l)
					}
				}
				return h
			},
			valHooks: {
				select: {
					get: function(f) {
						var c = [],
							d = f.options;
						for (var e = 0; e < d.length; e++) {
							if (d[e].selected) {
								c.push(d[e].value)
							}
						}
						if (c.length == 1) {
							return c[0]
						} else {
							if (c.length == 0) {
								return null
							} else {
								return c
							}
						}
					},
					set: function(g, c) {
						var d = g.options;
						var f = g.getAttribute("multiple") ? true : false;
						for (var e = 0; e < d.length; e++) {
							var h = d[e];
							h.selected = false;
							if (f) {
								if (xTouch.inArray(c, h.value)) {
									h.selected = true
								}
							} else {
								if (c == h.value) {
									h.selected = true;
									return
								}
							}
						}
					}
				}
			},
			dataset: function(d, c) {
				if (d.dataset) {
					return d.dataset[c]
				} else {
					return d.getAttribute("data-" + c)
				}
			},
			overWriteClass: function(e, c) {
				e && (e.className = c);
			},
			hasClass: function(e, c) {
				return new RegExp("(?:^|\\s)" + c + "(?:\\s|$)").test(e.className);
			},
			addClass: function(f, d) {
				var g = d.split(" "),
					e;
				e = xTouch.trim(f.className);
				if (!f.className) {
					f.className = d;
					return
				}
				e = " " + e + " ";
				for (var c = 0; c < g.length; c++) {
					if (e.indexOf(" " + g[c] + " ") == -1) {
						e += g[c] + " "
					}
				}
				f.className = xTouch.trim(e)
			},
			removeClass: function(e, c) {
				var d = e.className;
				if (d) {
					var re = new RegExp("(?:^|\\s)" + c + "(?:\\s|$)");
					e.className = xTouch.trim(d.replace(re, " ").replace(/\s{2,}/g, " "))
				}
			},
			toggleClass: function(d, c) {
				if (a.hasClass(d, c)) {
					a.removeClass(d, c)
				} else {
					a.addClass(d, c)
				}
			}
		};
		xTouch = function(d, c) {
			return new xTouch.fn.find(d, c)
		};
		xTouch._instance = function(c) {
			if (c && c.length) {
				for (var d = 0; d < c.length; d++) {
					this[d] = c[d]
				}
				this.length = c.length
			}
			return this
		};
		xTouch._emptyArray = [];
		xTouch.getEmptyArray = function() {
			xTouch._emptyArray.length = 0;
			return xTouch._emptyArray
		};
		xTouch.fn = xTouch.prototype = {
			length: 0,
			selector: "",
			find: function(g, f) {
				var c = xTouch.getEmptyArray();
				if (!g && !this.length) {
					return new xTouch._instance()
				}
				if (g && (g.nodeType || g === window)) {
					c[0] = g;
					return new xTouch._instance(c)
				}
				if (!f && this.length) {
					var h;
					for (var e = 0; e < this.length; e++) {
						if (g) {
							h = this[e].querySelectorAll(g)
						} else {
							h = this[e].childNodes
						}
						for (var d = 0; d < h.length; d++) {
							if (h[d].nodeType === 1) {
								c.push(h[d])
							}
						}
					}
				} else {
					f = f || document;
					if (typeof g === "string") {
						c = f.querySelectorAll(g)
					}
				}
				return new xTouch._instance(c)
			},
			children: function(c) {
				if (this.length == 0) {
					return this
				}
				if (c) {
					return this.find("* > " + c)
				} else {
					return this.find()
				}
			},
			parent: function() {
				if (this.length == 0) {
					return this
				}
				var c = xTouch.getEmptyArray();
				for (var d = 0; d < this.length; d++) {
					if (this[d].nodeType === 1) {
						c.push(this[d].parentNode)
					}
				}
				return new xTouch._instance(c)
			},
			each: function(d) {
				for (var c = 0; c < this.length; c++) {
					if (d.call(this[c], c, this[c]) === false) {
						break
					}
				}
				return this
			},
			bind: function(c, e) {
				for (var d = 0; d < this.length; d++) {
					this[d].addEventListener(c, e, false)
				}
				return this
			},
			unbind: function(c, e) {
				for (var d = 0; d < this.length; d++) {
					this[d].removeEventListener(c, e, false)
				}
				return this
			}
		};
		xTouch._instance.prototype = xTouch.fn;
		xTouch.extend = xTouch.fn.extend = function(e) {
			var d = e;
			if (typeof e === "function") {
				d = e.call(null, xTouch)
			}
			if (!d) {
				return
			}
			for (var c in d) {
				xTouch.fn[c] = d[c]
			}
		};
		xTouch.ready = function(c) {
			if (document.readyState === "complete" || document.readyState === "loaded" || document.readyState === "interactive") {
				c.call(null);
				return
			} else {
				document.addEventListener("DOMContentLoaded", c, false)
			}
		};
		xTouch.extend({
			html: function(c) {
				if (c === b) {
					var e = this[0];
					return (e && e.nodeType === 1) ? this[0].innerHTML : null
				}
				for (var d = 0; d < this.length; d++) {
					this[d].innerHTML = c
				}
				return this
			},
			text: function(c) {
				if (c === b) {
					return xTouch.decodeHTML(this.html(c))
				}
				this.html(xTouch.encodeHTML(c));
				return this
			},
			val: function(c) {
				if (c === b) {
					var f = this[0];
					if (!f) {
						return null
					}
					var e = a.valHooks[f.nodeName.toLowerCase()];
					return e ? e.get(f) : f.value
				}
				for (var d = 0; d < this.length; d++) {
					var f = this[d];
					var e = a.valHooks[f.nodeName.toLowerCase()];
					if (e) {
						e.set(f, c)
					} else {
						f.value = c
					}
				}
				return this
			},
			overWriteClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.overWriteClass(this[d], c)
				}
			},
			hasClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					if (a.hasClass(this[d], c)) {
						return true
					}
				}
				return false
			},
			addClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.addClass(this[d], c)
				}
				return this
			},
			removeClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.removeClass(this[d], c)
				}
				return this
			},
			toggleClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.toggleClass(this[d], c)
				}
				return this
			},
			attr: function(d, c) {
				return a.attr(this, d, c)
			},
			css: function(d, c) {
				return a.css(this, d, c)
			},
			blur: function() {
				this[0].blur();
				return this
			},
			focus: function() {
				this[0].focus();
				return this
			},
			size: function() {
				return this.length
			},
			remove: function() {
				var d;
				for (var c = 0; c < this.length; c++) {
					d = this[c];
					if (d.parentNode) {
						d.parentNode.removeChild(d)
					}
				}
				return this
			},
			append: function(f) {
				if (f === b) {
					return this
				}
				var e, d = f.nodeType;
				for (var c = 0; c < this.length; c++) {
					e = this[c];
					if (d) {
						e.appendChild(f)
					} else {
						e.innerHTML += f
					}
				}
				return this
			}
		});
		xTouch.extend({
			show: function(g) {
				var f, e, d = [];
				g = g || "block";
				for (var c = 0; c < this.length; c++) {
					f = this[c];
					e = f.style;
					if (e.display === "none") {
						e.display = ""
					}
					if (e.display === "" && a.css(f, "display") === "none") {
						d.push(f)
					}
				}
				for (var c = 0; c < d.length; c++) {
					d[c].style.display = g
				}
				return this
			},
			hide: function() {
				for (var c = 0; c < this.length; c++) {
					this[c].style.display = "none"
				}
				return this
			},
			visibility: function(c) {
				for (var d = 0; d < this.length; d++) {
					this[d].style.visibility = (c == true) ? "inherit" : "hidden"
				}
				return this
			}
		});
		xTouch.extend({
			dataset: function(c) {
				return a.dataset(this[0], c)
			}
		});
		xTouch.encodeHTML = function(c) {
			return c.replace ? c.replace(/</g, "&lt;").replace(/>/g, "&gt;") : c
		};
		xTouch.decodeHTML = function(c) {
			return c.replace ? c.replace(/&lt;/g, "<").replace(/&gt;/g, ">") : c
		};
		xTouch.inArray = function(e, c) {
			if (!e.length) {
				return e == c
			}
			for (var d = 0; d < e.length; d++) {
				if (e[d] == c) {
					return true
				}
			}
			return false
		};
		xTouch.trim = function(c) {
			if (!c) {
				return ""
			}
			if (c.trim) {
				return c.trim()
			} else {
				return c.replace(/^[\s\t ]+|[\s\t ]+$/g, "")
			}
		};
		xTouch.parseJSON = function(c) {
			if (!c) {
				return null
			}
			if (typeof c !== "string") {
				c = String(c);
			}
			if (window.JSON && window.JSON.parse) {
				try {
					return window.JSON.parse(c)
				} catch (d) {
					return (new Function("return " + xTouch.trim(c)))()
				}
			}
			return (new Function("return " + xTouch.trim(c)))()
		};
		xTouch.stringify = function(h) {
			if (window.JSON) {
				return JSON.stringify(h)
			}
			var g = typeof(h);
			if (g != "object" || h === null) {
				if (g == "string") {
					h = '"' + h + '"'
				}
				return String(h)
			} else {
				var i, e, f = [],
					c = (h && h.constructor == Array);
				var d = arguments.callee;
				for (i in h) {
					e = h[i];
					g = typeof(e);
					if (h.hasOwnProperty(i)) {
						if (g == "string") {
							e = '"' + e + '"'
						} else {
							if (g == "object" && e !== null) {
								e = d(e)
							}
						}
						f.push((c ? "" : '"' + i + '":') + String(e))
					}
				}
				return (c ? "[" : "{") + String(f) + (c ? "]" : "}")
			}
		};
		xTouch.pMethod = a
	})();
	(function() {
		var j = "tjs_views",
			h = j + "+=",
			i = ";",
			b = "+(",
			f = ")",
			e = 0;

		function k(l) {
			return l.replace(/\n/gm, "").replace(/"/gm, '\\"')
		}
		function a(l) {
			return l.replace(/(\W*)@(\w+)/gm, "$1tjs_data.$2")
		}
		function g(o, n) {
			if (o.length == 0) {
				return ""
			}
			var l = "";
			if (!n) {
				if (e === 1) {
					l = '+"' + k(o) + '"'
				} else {
					l = h + '"' + k(o) + '"'
				}
				e = 1
			} else {
				var m = o.charAt(0);
				if (m === "=") {
					if (e === 1) {
						l = b + a(o.substr(1)) + f
					} else {
						l = h + a(o.substr(1)) + i
					}
					e = 1
				} else {
					if (e === 1) {
						l = i
					}
					l += a(o);
					e = 2
				}
			}
			return l
		}
		function d(p) {
			var n = document.getElementById(p);
			if (n) {
				var l = n.innerHTML;
				var o = l.indexOf("<");
				var m = l.lastIndexOf(">");
				return l.substring(o + 4, m - 2)
			}
			return ""
		}
		var c = xTouch.tjs = function(n, q, w) {
			if (c[n]) {
				return c[n](q)
			}
			w = w || d;
			var u = w(n);
			if (!u) {
				return ""
			}
			e = 0;
			var s = "",
				v, r, o = u.length,
				m = "var tjs_views='';";
			for (var p = 0; p < o; p++) {
				v = u.charAt(p);
				switch (v) {
					case "[":
						r = u.charAt(++p);
						if (r === "%") {
							m += g(s, false);
							s = ""
						} else {
							s += v + r
						}
						break;
					case "]":
						r = u.charAt(p - 1);
						if (r === "%") {
							m += g(s.substr(0, s.length - 1), true);
							s = ""
						} else {
							s += v
						}
						break;
					default:
						s += v
				}
			}
			if (s.length !== 0) {
				m += g(s, false)
			}
			try {
				c[n] = new Function("tjs_data", m + ";return tjs_views;")
			} catch (t) {
				if ("console" in window) {
					console.log(m + ";return tjs_views;")
				}
				throw t
			}
			return c[n](q)
		}
	})();
	(function() {
		xTouch.extend({
			animate: function(c, b, f, g) {
				var h = typeof b,
					e = typeof f,
					j = (h === "number") ? b : 400,
					a = (h === "string") ? b : ((e === "string") ? f : "linear"),
				_callback = (h === "function") ? b : ((e === "function") ? f : g),
				cssValue = "all " + j + "ms " + a, count = this.length, callbacker = this, transitionEnd = function() {
					count--;
					if (count == 0) {
						for (var k = 0; k < callbacker.length; k++) {
							callbacker[k].style.removeProperty("-webkit-transition")
						}
						callbacker.unbind("webkitTransitionEnd", transitionEnd);
						if (_callback) {
							_callback.call(callbacker)
						}
					}
				};
				for (var d = 0; d < this.length; d++) {
					this[d].style["-webkit-transition"] = cssValue
				}
				this.bind("webkitTransitionEnd", transitionEnd);
				this.css(c)
			}
		})
	})();
	(function() {
		var a = {};
		xTouch.bindHashChange = function(c, b) {
			a[c] = b
		};
		xTouch.bindOtherHashChange = function(b) {
			a["__all__"] = b
		};
		xTouch.ready(function() {
			var c;

			function d() {
				var e = location.hash.match(/#([^\?]+)/);
				if (e) {
					e = e[1]
				}
				if (a[e]) {
					a[e].call(null, e)
				} else {
					if (a["__all__"]) {
						a["__all__"].call(null, e)
					}
				}
			}
			function b() {
				if (location.hash != c) {
					d();
					c = location.hash
				}
			}
			if ("onhashchange" in window) {
				window.addEventListener("hashchange", d);
				d()
			} else {
				window.setInterval(b, 200)
			}
		})
	})();
	return xTouch;
});

define("iScroll",function(){var a=Math,g=document,p=g.createElement("div").style,d=function(){var F="t,webkitT".split(","),G,m=0,H=F.length;for(;m<H;m++){G=F[m]+"ransform";if(G in p){return F[m].substr(0,F[m].length-1)}}return false}(),b=d?"-"+d.toLowerCase()+"-":"",e=f("transform"),w=f("transitionProperty"),q=f("transitionDuration"),x=f("transformOrigin"),D=f("transitionTimingFunction"),l=f("transitionDelay"),r=/android/gi.test(navigator.appVersion),s=/iphone|ipad/gi.test(navigator.appVersion),y=/hp-tablet/gi.test(navigator.appVersion),t=false,c="ontouchstart"in window&&!y,z=!!d,E=false,n="onorientationchange"in window?"orientationchange":"resize",o=c?"touchstart":"mousedown",h=c?"touchmove":"mousemove",i=c?"touchend":"mouseup",j=c?"touchcancel":"mouseup",A="mousewheel",B=function(){if(d===false){return false}var m={"":"transitionend",webkit:"webkitTransitionEnd"};return m[d]}(),C=function(){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||function(m){return setTimeout(m,1)}}(),u=function(){return window.cancelRequestAnimationFrame||window.webkitCancelAnimationFrame||window.webkitCancelRequestAnimationFrame||clearTimeout}(),k=t?" translateZ(0)":"",v=function(F,H){var m=this,G;m.wrapper=typeof F=="object"?F:g.getElementById(F);m.wrapper.style.overflow="hidden";m.scroller=m.wrapper.children[0];m.options={hScroll:true,vScroll:true,x:0,y:0,bounce:true,bounceLock:false,momentum:true,lockDirection:true,useTransform:true,useTransition:false,topOffset:0,checkDOMChanges:false,handleClick:true,hScrollbar:true,vScrollbar:true,fixedScrollbar:r,hideScrollbar:s,fadeScrollbar:s&&t,scrollbarClass:"",zoom:false,zoomMin:1,zoomMax:4,doubleTapZoom:2,wheelAction:"scroll",snap:false,snapThreshold:1,onRefresh:null,onBeforeScrollStart:null,onScrollStart:null,onBeforeScrollMove:null,onScrollMove:null,onBeforeScrollEnd:null,onScrollEnd:null,onTouchEnd:null,onInit:null};for(G in H){m.options[G]=H[G]}m.x=m.options.x;m.y=m.options.y;m.options.useTransform=true;m.options.useTransition=false;m.options.hScrollbar=m.options.hScroll&&m.options.hScrollbar;m.options.vScrollbar=m.options.vScroll&&m.options.vScrollbar;m.scroller.style[w]=m.options.useTransform?b+"transform":"top left";m.scroller.style[q]="0";m.scroller.style[x]="0 0";m.options.useTransform?m.scroller.style[e]="translate("+m.x+"px,"+m.y+"px)"+k:m.scroller.style.cssText+=";position:absolute;top:"+m.y+"px;left:"+m.x+"px";m.refresh();m._bind(n,window);m._bind(o);m.options.checkDOMChanges&&(m.checkDOMTime=setInterval(function(){m._checkDOMChanges()},500));m.options.onInit&&m.options.onInit.call(m)};v.prototype={enabled:true,x:0,y:0,steps:[],scale:1,currPageX:0,currPageY:0,pagesX:[],pagesY:[],aniTime:null,wheelZoomCount:0,handleEvent:function(m){var F=this;switch(m.type){case o:if(!c&&m.button!==0){		return}F._start(m);break;case h:F._move(m);break;case i:case j:F._end(m);break;case n:F._resize();break;case B:F._transitionEnd(m);break}},_checkDOMChanges:function(){if(this.moved||this.zoomed||this.animating||this.scrollerW==this.scroller.offsetWidth*this.scale&&this.scrollerH==this.scroller.offsetHeight*this.scale){return}this.refresh()},_scrollbar:function(F){var m=this,G;if(!m[F+"Scrollbar"]){m[F+"ScrollbarWrapper"]&&(z&&(m[F+"ScrollbarIndicator"].style[e]=""),m[F+"ScrollbarWrapper"].parentNode.removeChild(m[F+"ScrollbarWrapper"]),m[F+"ScrollbarWrapper"]=null,m[F+"ScrollbarIndicator"]=null);return}!m[F+"ScrollbarWrapper"]&&(G=g.createElement("div"),m.options.scrollbarClass?G.className=m.options.scrollbarClass+F.toUpperCase():G.style.cssText="position:absolute;z-index:100;"+(F=="h"?"height:7px;bottom:1px;left:2px;right:"+(m.vScrollbar?"7":"2")+"px":"width:7px;bottom:"+(m.hScrollbar?"7":"2")+"px;top:2px;right:1px"),G.style.cssText+=";pointer-events:none;"+b+"transition-property:opacity;"+b+"transition-duration:"+(m.options.fadeScrollbar?"350ms":"0")+";overflow:hidden;opacity:"+(m.options.hideScrollbar?"0":"1"),m.wrapper.appendChild(G),m[F+"ScrollbarWrapper"]=G,G=g.createElement("div"),!m.options.scrollbarClass&&(G.style.cssText="position:absolute;z-index:100;background:rgba(0,0,0,0.5);border:1px solid rgba(255,255,255,0.9);"+b+"background-clip:padding-box;"+b+"box-sizing:border-box;"+(F=="h"?"height:100%":"width:100%")+";"+b+"border-radius:3px;border-radius:3px"),G.style.cssText+=";pointer-events:none;"+b+"transition-property:"+b+"transform;"+b+"transition-timing-function:cubic-bezier(0.33,0.66,0.66,1);"+b+"transition-duration:0;"+b+"transform: translate(0,0)"+k,m.options.useTransition&&(G.style.cssText+=";"+b+"transition-timing-function:cubic-bezier(0.33,0.66,0.66,1)"),m[F+"ScrollbarWrapper"].appendChild(G),m[F+"ScrollbarIndicator"]=G);F=="h"?(m.hScrollbarSize=m.hScrollbarWrapper.clientWidth,m.hScrollbarIndicatorSize=a.max(a.round(m.hScrollbarSize*m.hScrollbarSize/m.scrollerW),8),m.hScrollbarIndicator.style.width=m.hScrollbarIndicatorSize+"px",m.hScrollbarMaxScroll=m.hScrollbarSize-m.hScrollbarIndicatorSize,m.hScrollbarProp=m.hScrollbarMaxScroll/m.maxScrollX):(m.vScrollbarSize=m.vScrollbarWrapper.clientHeight,m.vScrollbarIndicatorSize=a.max(a.round(m.vScrollbarSize*m.vScrollbarSize/m.scrollerH),8),m.vScrollbarIndicator.style.height=m.vScrollbarIndicatorSize+"px",m.vScrollbarMaxScroll=m.vScrollbarSize-m.vScrollbarIndicatorSize,m.vScrollbarProp=m.vScrollbarMaxScroll/m.maxScrollY);m._scrollbarPos(F,true)},_resize:function(){var m=this;setTimeout(function(){m.refresh()},r?200:0)},_pos:function(m,F){m=this.hScroll?m:0;F=this.vScroll?F:0;this.scroller.style[e]="translate("+m+"px,"+F+"px) scale("+this.scale+")"+k;this.x=m;this.y=F;this._scrollbarPos("h");this._scrollbarPos("v")},_scrollbarPos:function(F,I){var m=this,G=F=="h"?m.x:m.y,H;if(!m[F+"Scrollbar"]){return}G=m[F+"ScrollbarProp"]*G;G<0?(!m.options.fixedScrollbar&&(H=m[F+"ScrollbarIndicatorSize"]+a.round(G*3),H<8&&(H=8),m[F+"ScrollbarIndicator"].style[F=="h"?"width":"height"]=H+"px"),G=0):G>m[F+"ScrollbarMaxScroll"]&&(!m.options.fixedScrollbar?(H=m[F+"ScrollbarIndicatorSize"]-a.round((G-m[F+"ScrollbarMaxScroll"])*3),H<8&&(H=8),m[F+"ScrollbarIndicator"].style[F=="h"?"width":"height"]=H+"px",G=m[F+"ScrollbarMaxScroll"]+(m[F+"ScrollbarIndicatorSize"]-H)):G=m[F+"ScrollbarMaxScroll"]);m[F+"ScrollbarWrapper"].style[l]="0";m[F+"ScrollbarWrapper"].style.opacity=I&&m.options.hideScrollbar?"0":"1";m[F+"ScrollbarIndicator"].style[e]="translate("+(F=="h"?G+"px,0)":"0,"+G+"px)")+k},_start:function(F){var m=this,J=c?F.touches[0]:F,G,H,I,K,L;if(!m.enabled){return}m.options.onBeforeScrollStart&&m.options.onBeforeScrollStart.call(m,F);m.moved=false;m.animating=false;m.zoomed=false;m.distX=0;m.distY=0;m.absDistX=0;m.absDistY=0;m.dirX=0;m.dirY=0;m.options.momentum&&(G=getComputedStyle(m.scroller,null)[e].replace(/[^0-9\-.,]/g,"").split(","),H=+G[4],I=+G[5],(H!=m.x||I!=m.y)&&(u(m.aniTime),m.steps=[],m._pos(H,I),m.options.onScrollEnd&&m.options.onScrollEnd.call(m,F)));m.absStartX=m.x;m.absStartY=m.y;m.startX=m.x;m.startY=m.y;m.pointX=J.pageX;m.pointY=J.pageY;m.startTime=F.timeStamp||Date.now();m.options.onScrollStart&&m.options.onScrollStart.call(m,F);m._bind(h,window);m._bind(i,window);m._bind(j,window)},_move:function(H){var m=this,K=c?H.touches[0]:H,F=K.pageX-m.pointX,G=K.pageY-m.pointY,I=m.x+F,J=m.y+G,M,N,O,L=H.timeStamp||Date.now();m.options.onBeforeScrollMove&&m.options.onBeforeScrollMove.call(m,H);(m.hScroll&&Math.abs(F)>Math.abs(G)||m.vScroll&&Math.abs(F)<Math.abs(G))&&H.preventDefault();m.pointX=K.pageX;m.pointY=K.pageY;(I>0||I<m.maxScrollX)&&(I=m.options.bounce?m.x+F/2:I>=0||m.maxScrollX>=0?0:m.maxScrollX);(J>m.minScrollY||J<m.maxScrollY)&&(J=m.options.bounce?m.y+G/2:J>=m.minScrollY||m.maxScrollY>=0?m.minScrollY:m.maxScrollY);m.distX+=F;m.distY+=G;m.absDistX=a.abs(m.distX);m.absDistY=a.abs(m.distY);if(m.absDistX<6&&m.absDistY<6){return}m.options.lockDirection&&(m.absDistX>m.absDistY+5?(J=m.y,G=0):m.absDistY>m.absDistX+5&&(I=m.x,F=0));m.moved=true;m._pos(I,J);m.dirX=F>0?-1:F<0?1:0;m.dirY=G>0?-1:G<0?1:0;L-m.startTime>300&&(m.startTime=L,m.startX=m.x,m.startY=m.y);m.options.onScrollMove&&m.options.onScrollMove.call(m,H)},_end:function(F){if(c&&F.touches.length!==0){return}var m=this,M=c?F.changedTouches[0]:F,J,N,K={dist:0,time:0},L={dist:0,time:0},R=(F.timeStamp||Date.now())-m.startTime,G=m.x,H=m.y,O,P,Q,I,S;m._unbind(h,window);m._unbind(i,window);m._unbind(j,window);m.options.onBeforeScrollEnd&&m.options.onBeforeScrollEnd.call(m,F);if(!m.moved){c&&this.options.handleClick&&(m.doubleTapTimer=setTimeout(function(){m.doubleTapTimer=null;J=M.target;while(J.nodeType!=1){J=J.parentNode}J.tagName!="SELECT"&&J.tagName!="INPUT"&&J.tagName!="TEXTAREA"&&(N=g.createEvent("MouseEvents"),N.initMouseEvent("click",true,true,F.view,1,M.screenX,M.screenY,M.clientX,M.clientY,F.ctrlKey,F.altKey,F.shiftKey,F.metaKey,0,null),N._fake=true,J.dispatchEvent(N))},m.options.zoom?250:0));m._resetPos(400);m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F);return}R<300&&m.options.momentum&&(K=G?m._momentum(G-m.startX,R,-m.x,m.scrollerW-m.wrapperW+m.x,m.options.bounce?m.wrapperW:0):K,L=H?m._momentum(H-m.startY,R,-m.y,m.maxScrollY<0?m.scrollerH-m.wrapperH+m.y-m.minScrollY:0,m.options.bounce?m.wrapperH:0):L,G=m.x+K.dist,H=m.y+L.dist,(m.x>0&&G>0||m.x<m.maxScrollX&&G<m.maxScrollX)&&(K={dist:0,time:0}),(m.y>m.minScrollY&&H>m.minScrollY||m.y<m.maxScrollY&&H<m.maxScrollY)&&(L={dist:0,time:0}));if(K.dist||L.dist){Q=a.max(a.max(K.time,L.time),10);m.options.snap&&(O=G-m.absStartX,P=H-m.absStartY,a.abs(O)<m.options.snapThreshold&&a.abs(P)<m.options.snapThreshold?m.scrollTo(m.absStartX,m.absStartY,200):(I=m._snap(G,H),G=I.x,H=I.y,Q=a.max(I.time,Q)));m.scrollTo(a.round(G),a.round(H),Q);m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F);return}if(m.options.snap){O=G-m.absStartX;P=H-m.absStartY;a.abs(O)<m.options.snapThreshold&&a.abs(P)<m.options.snapThreshold?m.scrollTo(m.absStartX,m.absStartY,200):(I=m._snap(m.x,m.y),(I.x!=m.x||I.y!=m.y)&&m.scrollTo(I.x,I.y,I.time));m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F);return}m._resetPos(200);m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F)},_resetPos:function(H){var m=this,F=m.x>=0?0:m.x<m.maxScrollX?m.maxScrollX:m.x,G=m.y>=m.minScrollY||m.maxScrollY>0?m.minScrollY:m.y<m.maxScrollY?m.maxScrollY:m.y;if(F==m.x&&G==m.y){m.moved&&(m.moved=false,m.options.onScrollEnd&&m.options.onScrollEnd.call(m));m.hScrollbar&&m.options.hideScrollbar&&(d=="webkit"&&(m.hScrollbarWrapper.style[l]="300ms"),m.hScrollbarWrapper.style.opacity="0");m.vScrollbar&&m.options.hideScrollbar&&(d=="webkit"&&(m.vScrollbarWrapper.style[l]="300ms"),m.vScrollbarWrapper.style.opacity="0");return}m.scrollTo(F,G,H||0)},_startAni:function(){var m=this,G=m.x,H=m.y,K=Date.now(),F,I,J;if(m.animating){return}if(!m.steps.length){m._resetPos(400);return}F=m.steps.shift();F.x==G&&F.y==H&&(F.time=0);m.animating=true;m.moved=true;J=function(){var L=Date.now(),M,N;if(L>=K+F.time){m._pos(F.x,F.y);m.animating=false;m.options.onAnimationEnd&&m.options.onAnimationEnd.call(m);m._startAni();return}L=(L-K)/F.time-1;I=a.sqrt(1-L*L);M=(F.x-G)*I+G;N=(F.y-H)*I+H;m._pos(M,N);m.animating&&(m.aniTime=C(J))};J()},_momentum:function(I,N,G,H,L){var J=0.0006,F=a.abs(I)/N,m=F*F/(2*J),M=0,K=0;I>0&&m>G?(K=L/(6/(m/F*J)),G=G+K,F=F*G/m,m=G):I<0&&m>H&&(K=L/(6/(m/F*J)),H=H+K,F=F*H/m,m=H);m=m*(I<0?-1:1);M=F/J;return{dist:m,time:a.round(M)}},_offset:function(m){var F=-m.offsetLeft,G=-m.offsetTop;while(m=m.offsetParent){F-=m.offsetLeft;G-=m.offsetTop}return{left:F,top:G}},_snap:function(H,I){var m=this,G,L,F,M,J,K;F=m.pagesX.length-1;for(G=0,L=m.pagesX.length;G<L;G++){if(H>=m.pagesX[G]){F=G;break}}F==m.currPageX&&F>0&&m.dirX<0&&F--;H=m.pagesX[F];J=a.abs(H-m.pagesX[m.currPageX]);J=J?a.abs(m.x-H)/J*500:0;m.currPageX=F;F=m.pagesY.length-1;for(G=0;G<F;G++){if(I>=m.pagesY[G]){F=G;break}}F==m.currPageY&&F>0&&m.dirY<0&&F--;I=m.pagesY[F];K=a.abs(I-m.pagesY[m.currPageY]);K=K?a.abs(m.y-I)/K*500:0;m.currPageY=F;M=a.round(a.max(J,K))||200;return{x:H,y:I,time:M}},_bind:function(m,F,G){(F||this.scroller).addEventListener(m,this,!!G)},_unbind:function(m,F,G){(F||this.scroller).removeEventListener(m,this,!!G)},destroy:function(){var m=this;m.scroller.style[e]="";m.hScrollbar=false;m.vScrollbar=false;m._scrollbar("h");m._scrollbar("v");m._unbind(n,window);m._unbind(o);m._unbind(h,window);m._unbind(i,window);m._unbind(j,window);!m.options.hasTouch&&m._unbind(A);m.options.checkDOMChanges&&clearInterval(m.checkDOMTime);m.options.onDestroy&&m.options.onDestroy.call(m)},refresh:function(){var m=this,I,G,K,J,F=0,H=0;m.scale<m.options.zoomMin&&(m.scale=m.options.zoomMin);m.wrapperW=m.wrapper.clientWidth||1;m.wrapperH=m.wrapper.clientHeight||1;m.minScrollY=-m.options.topOffset||0;m.scrollerW=a.round(m.scroller.offsetWidth*m.scale);m.scrollerH=a.round((m.scroller.offsetHeight+m.minScrollY)*m.scale);m.maxScrollX=m.wrapperW-m.scrollerW;m.maxScrollY=m.wrapperH-m.scrollerH+m.minScrollY;m.dirX=0;m.dirY=0;m.options.onRefresh&&m.options.onRefresh.call(m);m.hScroll=m.options.hScroll&&m.maxScrollX<0;m.vScroll=m.options.vScroll&&(!m.options.bounceLock&&!m.hScroll||m.scrollerH>m.wrapperH);m.hScrollbar=m.hScroll&&m.options.hScrollbar;m.vScrollbar=m.vScroll&&m.options.vScrollbar&&m.scrollerH>m.wrapperH;I=m._offset(m.wrapper);m.wrapperOffsetLeft=-I.left;m.wrapperOffsetTop=-I.top;if(typeof m.options.snap=="string"){m.pagesX=[];m.pagesY=[];J=m.scroller.querySelectorAll(m.options.snap);for(G=0,K=J.length;G<K;G++){F=m._offset(J[G]);F.left+=m.wrapperOffsetLeft;F.top+=m.wrapperOffsetTop;m.pagesX[G]=F.left<m.maxScrollX?m.maxScrollX:F.left*m.scale;m.pagesY[G]=F.top<m.maxScrollY?m.maxScrollY:F.top*m.scale}}else if(m.options.snap){m.pagesX=[];while(F>=m.maxScrollX){m.pagesX[H]=F;F=F-m.wrapperW;H++}m.maxScrollX%m.wrapperW&&(m.pagesX[m.pagesX.length]=m.maxScrollX-m.pagesX[m.pagesX.length-1]+m.pagesX[m.pagesX.length-1]);F=0;H=0;m.pagesY=[];while(F>=m.maxScrollY){m.pagesY[H]=F;F=F-m.wrapperH;H++}m.maxScrollY%m.wrapperH&&(m.pagesY[m.pagesY.length]=m.maxScrollY-m.pagesY[m.pagesY.length-1]+m.pagesY[m.pagesY.length-1])}m._scrollbar("h");m._scrollbar("v");m.scroller.style[q]="0";m._resetPos(400)},scrollTo:function(H,J,K,L){var G=this,m=H,F,I;G.stop();!m.length&&(m=[{x:H,y:J,time:K,relative:L}]);for(F=0,I=m.length;F<I;F++){m[F].relative&&(m[F].x=G.x-m[F].x,m[F].y=G.y-m[F].y);G.steps.push({x:m[F].x,y:m[F].y,time:m[F].time||0})}G._startAni()},scrollToElement:function(G,H){var F=this,m;G=G.nodeType?G:F.scroller.querySelector(G);if(!G){return}m=F._offset(G);m.left+=F.wrapperOffsetLeft;m.top+=F.wrapperOffsetTop;m.left=m.left>0?0:m.left<F.maxScrollX?F.maxScrollX:m.left;m.top=m.top>F.minScrollY?F.minScrollY:m.top<F.maxScrollY?F.maxScrollY:m.top;H=H===undefined?a.max(a.abs(m.left)*2,a.abs(m.top)*2):H;F.scrollTo(m.left,m.top,H)},scrollToPage:function(F,G,J){var m=this,H,I;J=J===undefined?400:J;m.options.onScrollStart&&m.options.onScrollStart.call(m);m.options.snap?(F=F=="next"?m.currPageX+1:F=="prev"?m.currPageX-1:F,G=G=="next"?m.currPageY+1:G=="prev"?m.currPageY-1:G,F=F<0?0:F>m.pagesX.length-1?m.pagesX.length-1:F,G=G<0?0:G>m.pagesY.length-1?m.pagesY.length-1:G,m.currPageX=F,m.currPageY=G,H=m.pagesX[F],I=m.pagesY[G]):(H=-m.wrapperW*F,I=-m.wrapperH*G,H<m.maxScrollX&&(H=m.maxScrollX),I<m.maxScrollY&&(I=m.maxScrollY));m.scrollTo(H,I,J)},stop:function(){u(this.aniTime);this.steps=[];this.moved=false;this.animating=false}};function f(m){if(d===""){return m}m=m.charAt(0).toUpperCase()+m.substr(1);return d+m}p=null;return v});define("Str",function(){var a={RegExps:{cut:/[\x00-\xFF]/,getRealLen:{r0:/[^\x00-\xFF]/g,r1:/[\x00-\xFF]/g},escHTML:{re_amp:/&/g,re_lt:/</g,re_gt:/>/g,re_apos:/'/g,re_quot:/"/g},escString:{bsls:/\\/g,sls:/\//g,nl:/\n/g,rt:/\r/g,tab:/\t/g},restXHTML:{re_amp:/&amp;/g,re_lt:/&lt;/g,re_gt:/&gt;/g,re_apos:/&(?:apos|#0?39);/g,re_quot:/&quot;/g}},cut:function(b,d,e){b=String(b);d-=0;e=e||"";if(isNaN(d)){return b}var f=b.length,c=Math.min(Math.floor(d/2),f),g=a.getRealLen(b.slice(0,c));for(;c<f&&g<d;c++){g+=1+(b.charCodeAt(c)>255)}return b.slice(0,g>d?c-1:c)+(c<f?e:"")},cutRealLen:function(b,c,d){if(a.getRealLen(b)>c){return a.cut(b,c-a.getRealLen(d),d)}return b},getRealLen:function(b,d){if(typeof b!="string"){return 0}if(!d){return b.replace(a.RegExps.getRealLen.r0,"**").length}else{var c=b.replace(a.RegExps.getRealLen.r1,"");return b.length-c.length+encodeURI(c).length/3}},escString:function(d){var b=a.RegExps.escString,c=a.RegExps.escHTML;return a.listReplace(d+"",{"\\\\":b.bsls,"\\n":b.nl,"":b.rt,"\\t":b.tab,"\\/":b.sls,"\\'":c.re_apos,'\\"':c.re_quot})},escHTML:function(c){var b=a.RegExps.escHTML;return a.listReplace(c+"",{"&amp;":b.re_amp,"&lt;":b.re_lt,"&gt;":b.re_gt,"&#039;":b.re_apos,"&quot;":b.re_quot})},escRegExp:function(b){return b.replace(/([\\\^\$\(\)\[\]\{\}\*\+\.\?\/\|])/g,"\\$1")},reEscHTML:function(c){var b=a.RegExps.restXHTML;return a.listReplace(c+"",{"<":b.re_lt,">":b.re_gt,"\x27":b.re_apos,"\x22":b.re_quot,"&":b.re_amp})},listReplace:function(b,c,d){if(require("Type").isObject(c)){require("Util").each(c,function(e,f){b=b.replace(e,f)});return b}else{return b.replace(c,d)}},tmpl:function(f,d){d=d||{};var c=["var __=[];"],e=/([\s\S]*?)(?:(?:<%([^=][\s\S]*?)%>)|(?:<%=([\s\S]+?)%>)|$)/g;e.lastIndex=0;var b=e.exec(f||"");while(b&&(b[1]||b[2]||b[3])){b[1]&&c.push("__.push('",b[1].replace(/\\/g,"\\\\").replace(/\n/g,"\\n").replace(/\r/g,"").replace(/\t/g,"\t").replace(/\//g,"\\/").replace(/'/g,"\\'").replace(/"/g,'\\"'),"');");b[2]&&c.push(b[2]);b[3]&&c.push("__.push(",b[3],");");b=e.exec(f)}c.push("return __.join('');");var g=[],h=[];for(var i in d){g.push(i);h.push(d[i])}c=new Function(g.join(","),c.join(""));return c.apply(null,h)},trim:function(b){return b.replace(/^\s+|\s+$/g,"")},escDescHTML:function(b,c){if(b){switch(c){case 1:b=b.replace(/<[!\/]?(?!br\b|p\b)[\w-]+[^>]*>/g,"");break;case 0:default:b=b.replace(/<[!\/]?[\w-]+[^>]*>/g,"");break}}return b}};return a});define("Type",function(){var a={is:function(c,b){var d=Object.prototype.toString.call(b).slice(8,-1);return b!==undefined&&b!==null&&d===c},isNumber:function(b){return a.is("Number",b)},isString:function(b){return a.is("String",b)},isFunction:function(b){return a.is("Function",b)},isObject:function(b){return a.is("Object",b)},isArray:function(b){return a.is("Array",b)},isBoolean:function(b){return a.is("Boolean",b)}};return a});define("Util",function(){var a={extend:function(b,c){if(!b){return c}for(var d in c){b[d]=c[d]}return b},each:function(b,d){if(!b){return false}var e,f=0;if(require("Type").isObject(b)){for(var c in b){if(d.call(b[c],b[c],c,b)===false){break}}}else{require("Type").isArray(b)&&b.forEach(function(g,h){d.call(g,g,h,b)})}return b},log:function(){window.console&&console.log.apply(console,arguments)},logError:function(b){a.log(b.name+" : "+b.message+" \n stack :"+b.stack,b)},emptyFun:function(){},getUrlParam:function(e,f,b){var g=new RegExp("[?#&]"+e+"=([^&#]*)","i"),b=b||window.location.href,d=g.exec(b),c=d?d[1]:"";c=c.replace(/[+]/ig,"%20");return !f?decodeURIComponent(c):c},formatUsercount:function(b){!/[亿万个]/.test(b)&&(b=parseInt(b,10),!isNaN(b)&&(b>=1e8?b=Math.round(b/1e8)+"亿":b<1e8&&b>=1e4?b=Math.round(b/1e4)+"万":b=b+"个"));return b||0},delegate:function(b,g,e,d,c){var f=require("$");b=f(b)[0];var h=function(k){if(d&&f(b).find(d)){var i=Element.prototype,l=null,m=i.matchesSelector||i.mozMatchesSelector||i.webkitMatchesSelector||i.msMatchesSelector||i.oMatchesSelector,j=k.target;while(j!=b){if(m.call(j,d)){l=j;break}j=j.parentNode}l&&e.apply(l,[k].concat(require("Type").isArray(c)&&[c]))}else{return e.apply(k.target,[k].concat(require("Type").isArray(c)&&[c]))}};b.addEventListener(g,h,false)},addToArray:function(b,c,d){if(require("Type").isArray(b)){c=[].concat(c);a.each(c,function(e){var f=b.indexOf(e);!(-1<f)&&(!d?b.push(e):b.unshift(e))});return b}return false},removeFromArray:function(b,c){if(require("Type").isArray(b)){c=[].concat(c);a.each(c,function(e){var d=b.indexOf(e);-1<d&&b.splice(d,1)});return b}return false},formatTime:function(e){var c=parseInt((window.__responedTime-e)/1e3),d=new Date(),b=new Date(e);if(c<60){return"刚刚"}if(c<60*60){return parseInt(c/60)+"分钟前"}if(c<60*60*3){return parseInt(c/(60*60))+"小时前"}if(d.getDate()===b.getDate()){return"今天 "+b.getHours()+":"+(b.getMinutes()<10?"0":"")+b.getMinutes()}if(new Date(d.getTime()-24*60*60*1e3).getDate()===b.getDate()){return"昨天 "+b.getHours()+":"+(b.getMinutes()<10?"0":"")+b.getMinutes()}if(d.getFullYear()===b.getFullYear()){return b.getMonth()+1+"月"+b.getDate()+"日"}return b.getFullYear()+"年"+(b.getMonth()+1)+"月"+b.getDate()+"日"},hash:function(d){var b=5381;for(var c=0,e=d.length;c<e;++c){b+=(b<<5)+d.charCodeAt(c)}return b&2147483647},trigerCheckAndExecLast:function(c,d){var b=null,e=function(){try{c()}catch(f){}b=null};return function(){b&&(clearTimeout(b),b=null);b=setTimeout(e,d)}},greaterThanOrEqual:function(c,d){c=String(c).split(".");d=String(d).split(".");try{for(var b=0,g=Math.max(c.length,d.length);b<g;b++){var e=isFinite(c[b])&&Number(c[b])||0,f=isFinite(d[b])&&Number(d[b])||0;if(e<f){return false}else if(e>f){return true}}}catch(h){return false}return true}};return a});define("Events",function(c,b){var a=function(){this.listeners={}};a.prototype={on:function(d,e){!this.listeners[d]&&(this.listeners[d]=[]);this.listeners[d].push(e)},clear:function(d){this.listeners[d]&&(this.listeners[d]=[])},emit:function(d){try{!this.listeners[d]&&(this.listeners[d]=[]);var f=this.listeners[d],h=f.length,g=Array.prototype.slice.call(arguments,1);f.forEach(function(e){e.apply(null,g)})}catch(i){}}};b.eventEmitter=a});define("TapEvent",function(){var b=document.body;function i(k){return"tagName"in k?k:k.parentNode}function c(k,l,m,n){k.addEventListener(l,m,n)}function j(k){while(k&&k!=b){var l=k.ontap;if(l instanceof Function){return{onTap:l,scope:k}}l=k.getAttribute("ontap");if(l){return{onTap:new Function("event",l),scope:k}}k=k.parentNode}}function g(l,k,m){if(!("defaultPrevented"in k)){k.defaultPrevented=false;var n=k.preventDefault;k.preventDefault=function(){this.defaultPrevented=true;n.call(this)}}k.data=m;l.dispatchEvent(k)}function h(o,k){var m=document.createEvent("Events"),n=true;if(k){for(var l in k){l=="bubbles"?n=!!k[l]:m[l]=k[l]}}m.initEvent(o,n,true,null,null,null,null,null,null,null,null,null,null,null,null);return m}var a={},e,d="";function f(){e&&clearTimeout(e);e=null;a={}}c(b,"touchstart",function(k){a.el=i(k.touches[0].target);a.x1=k.touches[0].pageX;a.y1=k.touches[0].pageY;a.isMove=false;a.start=true;a.x2=a.y2=null},true);c(b,"touchmove",function(k){a.isMove=true;a.x2=k.touches[0].pageX;a.y2=k.touches[0].pageY},true);c(b,"touchend",function(l){d=d||"touchend";var k=false;a.isMove&&a.x2&&Math.abs(a.x1-a.x2)<5&&a.y2&&Math.abs(a.y1-a.y2)<5&&(k=true);if(a.start&&(!a.isMove||k)){if(d!="touchend"){return}e=setTimeout(function(){var m=h("tap");m.cancelTouch=f;g(a.el,m)},0)}},true);c(b,"touchcancel",f,true);c(window,"scroll",f,true);c(b,"tap",function(l){var k=j(l.target);if(k){var m=k.scope.getAttribute("tapEventTimer");if(m){return}m=setTimeout(function(){k.scope.setAttribute("tapEventTimer","")},500);k.scope.setAttribute("tapEventTimer",m);var n=k.onTap.call(k.scope,l);n===false&&l.preventDefault()}},false);c(b,"click",function(k){d=d||"click";if(d!="click"){return}var l=h("tap",k);l.cancelTouch=f;g(k.target,l)},false)});define("TimeStat",function(){var a=10,c={index:{flag:"7721-172-19".split("-"),rate:a,useOpenTime:false},"index-render":{flag:"7721-172-20".split("-"),rate:a,useOpenTime:false},"index-navstart":{flag:"7721-172-21".split("-"),rate:a,useOpenTime:false},"index-render-navstart":{flag:"7721-172-22".split("-"),rate:a,useOpenTime:false},detail:{flag:"7721-172-3".split("-"),rate:1,useOpenTime:true},"detail-render":{flag:"7721-172-4".split("-"),rate:1,useOpenTime:true},myapp:{flag:"7721-172-5".split("-"),rate:a,useOpenTime:true},"myapp-render":{flag:"7721-172-6".split("-"),rate:a,useOpenTime:true},category:{flag:"7721-172-7".split("-"),rate:1,useOpenTime:true},"category-render":{flag:"7721-172-8".split("-"),rate:1,useOpenTime:true},info:{flag:"7721-172-9".split("-"),rate:1,useOpenTime:true},"info-render":{flag:"7721-172-10".split("-"),rate:1,useOpenTime:true},search:{flag:"7721-172-11".split("-"),rate:a,useOpenTime:false},topic:{flag:"7721-172-12".split("-"),rate:1,useOpenTime:true},"topic-render":{flag:"7721-172-13".split("-"),rate:1,useOpenTime:true},cate:{flag:"7721-172-14".split("-"),rate:1,useOpenTime:true},"cate-render":{flag:"7721-172-15".split("-"),rate:1,useOpenTime:true}},b={pingURL:"http://isdspeed.qq.com/cgi-bin/r.cgi",isReported:false,report:function(d,f,i){try{if("search"!=d&&b.isReported){return}if(!i){return setTimeout(function(){b.report(d,f,true)},3e3)}b.isReported=true;f=f||window.timestamps||[];"search"!=d&&(d=d+(require("R").isRender?"-render":""),window.performance&&d.indexOf("index")>-1&&(d=d+(!!window.performance?"-navstart":""),window.performance.timing&&window.performance.timing.navigationStart>0&&f.unshift(window.performance.timing.navigationStart)));var g=c[d];if(!g){return}if(Math.random()>1/g.rate){return}var h=require("Api");require("Task").create(g.useOpenTime?h.getUrlParam("openTime"):false).then(function(m){if(g.useOpenTime){var k=parseInt(m);h.setUrlParam("openTime","");if(!k){return}f.unshift(new Date(k));if(f[1]-f[0]>500){return}}if(f.length<2){return}var l=["flag1="+g.flag[0],"flag2="+g.flag[1],"flag3="+g.flag[2],"flag5="+g.rate],n=f[0];for(var e=1;e<f.length;e++){l.push(e+"="+(f[e]-n))}require("PingSender").send(b.pingURL+"?"+l.join("&"));if("search"!=d&&d.indexOf("detail")==-1){var p=111+(require("LocalStorage").support?1:0)+(require("R").isRender?1:0);require("ValueStat").report("350594",1,p,{reportRate:g.rate})}}).start()}catch(j){}}};return b});define("Task",function(e,f,c){var b=function(g){return Object.prototype.toString.call(g).slice(8,-1)=="Function"},d=function(g){window.setTimeout(g,0)};function a(g){this.msg=g;this.state=a.STATE.INIT;this.reason=null;this.async=false;this.parent=null;this.handles=[];this.children=[];this.context={}}a.STATE={INIT:0,DELEGATING:1,FULFILLED:2,REJECTED:3,FINISH:4};a.isTask=function(g){return g&&b(g.then)};a.create=function(g){return new a(g)};a.exec=function(g,h,k){g.state=k;g.msg=h;if(a.STATE.FINISH==this.state){return g}if(a.isTask(h)){a.reCall(g,h);return g}var i=g.handles.shift();if(i){var j=a.strategy[i.cmd];j&&j.call(g,i)}else{!g.async&&g.parent&&g.parent.resolve(g.msg);!g.parent&&a.destroy(g)}return g};a.reCall=function(h,g){a.isTask(g)?(h.state=a.STATE.DELEGATING,g.parent=h,h.children.push(g),a.STATE.INIT==g.state?g.start():g.resolve(g.msg)):h.resolve(g)};a.destroy=function(g){g.children.forEach(function(h){a.destroy(h)});g.destroy()};a.strategy={then:function(j){var i=a.STATE,k=j.fulfilled,h=j.rejected,g="";try{i.FULFILLED==this.state&&(g=k&&k.call(this,this.msg));i.REJECTED==this.state&&(g=h&&h.call(this,this.msg))}catch(l){this.state=i.REJECTED;this.reason=l.message;g=h&&h.call(this,l)}this.msg=g;a.reCall(this,g)},map:function(m){var n=this,g=m.map,i={},h=0,j=function(k,p){h--;i[k]=p;h==0&&a.reCall(n,i)};b(g)&&(g=g.call(this,this.msg));for(var l in g){h++;var o=g[l];(function(p,k){d(function(){b(k)||a.isTask(k)?a.create(k).then(function(q){j(p,q)}).start():j(p,k)})})(l,o)}}};a.prototype.then=function(g,h){this.handles.push({cmd:"then",fulfilled:g,rejected:h});return this};a.prototype.map=function(g){this.handles.push({cmd:"map",map:g});return this};a.prototype.resolve=function(g){if(a.STATE.FINISH==this.state){return this}return a.exec(this,g,a.STATE.FULFILLED)};a.prototype.reject=function(g){return a.exec(this,g,a.STATE.REJECTED)};a.prototype.parentResolve=function(g){this.parent&&this.parent.resolve(g);return this};a.prototype.parentReject=function(g){this.parent&&this.parent.reject(g);return this};a.prototype.start=function(){while(b(this.msg)){this.msg=this.msg.call(this)}return this.resolve(this.msg)};a.prototype.destroy=function(){this.state=a.STATE.FINISH;this.reason=null;this.parent=null;this.handles=[];this.context={}};c.exports=a});define("Inview",function(){var b=require("$"),d=require("Type"),c=require("Events").eventEmitter,a={isInit:false,offset:0,pool:[],evt:new c(),on:function(){this.evt.on.apply(this.evt,arguments)},run:function(){var g=this.pool.length;if(g>0){var h=document.documentElement.clientHeight,n=0,o=0,p=null;tmpPool=[];for(var e=n;e<g;e++){var f=this.pool[e].node,j=this.pool[e].type,k=f.getBoundingClientRect(),l=k.top,m=k.bottom;f.clientHeight>0?l>0&&l<=h+a.offset||m>0&&m<=h+a.offset?(j&&this.evt.emit(j,f),f.removeAttribute("data-inview")):tmpPool.push(this.pool[e]):tmpPool.push(this.pool[e])}this.pool=tmpPool}},_bind:function(){a.on("imgLazyLoad",function(e){var f=e.getAttribute("_ori_src");f&&(e.src=f,e.removeAttribute("_ori_src"))})},bind:function(h){!this.isInit&&this._init();var g=b("[data-inview]"),j=false;this.pool=[];h&&h.length>0&&(j=true);for(var e=0,k=g.length;e<k;e++){var f=b(g[e]).attr("data-inview");j?f&&h.indexOf(f)>-1&&this.pool.push({node:g[e],type:f}):f&&this.pool.push({node:g[e],type:f})}setTimeout(function(){a.run()},0)},_init:function(){if(!this.isInit){a._bind();var e=null,f=function(){a.run();e=0};require("$")(window).bind("scroll",function(){e&&clearTimeout(e);e=setTimeout(f,50)});this.isInit=true}}};return a});define("Const",function(){var c=require("LocalStorage"),g=require("Util"),b=window.agentData||{},a=require("Util").getUrlParam("mobileInfo");a=a&&require("$").parseJSON(a);var d=/QQ\/([\d.]+)/.exec(navigator.userAgent);d&&(d=d[1]);var e=/ApiLevel\/(\d+)/.exec(navigator.userAgent);e&&(e=parseInt(e[1])||0);var f={appid:"100",QQVer:d,ApiLevel:e,Currentversion:a&&a.qz_ver||b.currentVersion||c.get("currentVersion"),Platform:a&&a.platform||b.platform||c.get("platform"),Uin:g.getUrlParam("uin")||b.uin,Sid:g.getUrlParam("sid")||"",url_prex:"http://app.z.qq.com/",channelId:1e3,app_custom:"",AgentVersion:a&&a.sdk_ver||b.agentVersion||c.get("agentVersion"),MobileInfo:a||require("$").parseJSON(b.mobileInfo||c.get("mobileInfo")),Display:a&&a.resolution||b.display||c.get("display"),pageParams:b.pageParams||"",debug:false};f.Uin&&require("LocalStorage").set("uin",f.Uin);return f});define("LocalAppFileds",{pName:0,versionCode:1,versionName:2,name:3});define("QzoneApp",{Api:{},Mod:{}});define("JsBridge",function(){var a={callback:function(){require("Event").fire.apply(require("Event"),arguments)}};return a});define("Config",{app:"qzone_app",db:"qzone_db",http:"qzone_http",image:"qzone_imageCache",worker:"q_worker",download:"q_download",client:"qqZoneAppList",qqApi:"QQApi"});define("Bridge",function(){var a=require("LocalStorage"),d=require("Const"),c=require("Util").greaterThanOrEqual(d.QQVer,"5.2")&&d.ApiLevel>13?4:3,b={enableCompatible:parseInt(a.get("bridge_enableCompatible"))||1,compatible:parseInt(a.get("bridge_compatible"))||c,reduce:function(){this.compatible-1<this.enableCompatible&&(this.compatible>1&&this.compatible--,a.set("bridge_compatible",this.compatible),a.set("bridge_compatible_time",Date.now()))},updateCompatible:function(){this.enableCompatible<this.compatible&&(this.enableCompatible=this.compatible,a.set("bridge_enableCompatible",this.enableCompatible))},createIframe:function(){var e=document.createElement("iframe");e.style.cssText="display:none;width:0px;height:0px;";document.body.appendChild(e);return e},removeIframe:function(f){var e=document.querySelector("iframe_jsBridge_"+f);e&&(e.src="about:blank",document.body.removeChild(e))},send:function(l,g,h,n){var i=n||{},j="jsbridge://"+[encodeURIComponent(l),encodeURIComponent(g),i.guid||0].join("/");h.forEach(function(e){j+="/"+encodeURIComponent(String(e))});var m=function(){var e=b.createIframe();e.id="iframe_jsBridge_"+i.guid;e.src=j};try{switch(b.compatible){case 4:var k="";"callBatch"!=g?k=require("$").stringify([].concat({ns:l,method:g,guid:i.guid,args:h||[]})):k=h[0];var f=new XMLHttpRequest();f.onload=function(q){try{var o=f.responseText&&JSON.parse(f.responseText)||[];window.QzoneApp.fire("batchCallback",o)}catch(r){}};f.open("get","/call?callbatch="+encodeURIComponent(k)+"&dayfly="+Math.random(),true);f.send();break;case 3:console.log(j);break;case 2:case 1:m();break;default:require("M").stringReport({errMsg:"JSBridge do not support this compatible mode : "+b.compatible,code:-460,duration:0})}}catch(p){this.compatible=0;m()}}};b.compatible!=c&&Date.now()-parseInt(a.get("bridge_compatible_time"))>6048e5&&(b.compatible=c);return b});define("Notify",function(a,c){var i=a("Collector"),g=5e3,d=new i(500,10),e={},f=[],b=[],h=function(){var j=a("Bridge"),k=f.splice(0);j.compatible>1&&j.enableCompatible<j.compatible?(j.reduce(),k.forEach(function(l){var m=l&&l[3];m.guid&&(b[m.guid]&&clearTimeout(b[m.guid]),m.timeout&&(b[m.guid]=setTimeout(h,g)),f.push(l),d.push({ns:l[0],method:l[1],guid:m.guid,args:l[2]}))})):a("M").stringReport({errMsg:"JSBridge do not support iframe compatible mode : "+j.compatible,code:-460,duration:0})};c.combineRequest=true;c.pull=function(l,k,j,m){return a("Task").create(function(){var q=this,p=a("Type"),n=m||{};!n.guid&&(n.guid=function(){var o=a("AsyncInterface").add(k,function(s){var r=a("Bridge");if(b[o]){clearTimeout(b[o]);r.updateCompatible();var t=110+r.compatible;a("ValueStat").report("350716",1,t,{reportRate:r.compatible>=3?10:1})}q.parentResolve(s.data);delete e[o];delete b[o];r.compatible==0&&r.removeIframe(o)});return o}());j&&(p.isObject(j)&&(j=a("$").stringify(j)),!p.isArray(j)&&(j=[].concat(j)));e[n.guid]=Date.now();n.timeout&&(b[n.guid]=setTimeout(h,g));f.push([l,k,j||[],n]);!n.immediately&&c.combineRequest?d.push({ns:l,method:k,guid:n.guid,args:j||[]}):a("Bridge").send(l,k,j||[],n);this.async=true})};c.sendBatch=function(j){a("Bridge").send(a("Config").client,"callBatch",[a("$").stringify(j),"500","10"],{guid:a("AsyncInterface").up()})};c.getDuration=function(j){return e[j]||0};d.on("fulled",c.sendBatch)});define("BatchCallback",function(){var a={init:function(){require("Event").on("batchCallback",function(b){b.r==0?require("Type").isArray(b.data)&&require("Util").each(b.data,function(c){QzoneApp.fire.apply(QzoneApp.fire,c)}):require("M").stringReport({errMsg:"BatchCallback error msg : "+b.data,code:-560,duration:0})})}};a.init();return a});define("Api",function(){var a=require("Const"),b=require("Config").client,c={get:function(d,e){if(!a[d]||e){return require("Task").create(require("Notify").pull(b,"get"+d)).then(function(f){a[d]=f;d=="Uin"&&require("LocalStorage").set("uin",f);return f})}else{return a[d]}},getUrlParam:function(d,e,i){var f=require("Util"),g=a.pageParams,h=f.getUrlParam(d,e,i||g);if(!h&&!g){return require("Task").create(require("Notify").pull(b,"getParams")).then(function(j){a.pageParams=j;return f.getUrlParam(d,e,j)})}return h},getMobileInfo:function(d){return !d&&a.MobileInfo?a.MobileInfo:require("Task").create(this.get("MobileInfo",true)).then(function(e){a.MobileInfo=require("$").parseJSON(e);return a.MobileInfo})},openLocalUrl:function(d){d.url="sd://"+d.url;c.openUrl(d)},openUrl:function(e){var d=e;if(""==d.url){return}d.current=d.current||0;d.titleInfo=d.titleInfo?[].concat(d.titleInfo):[];require("Notify").pull(b,"goUrl",d,{immediately:true}).start()},showMsg:function(d){require("Notify").pull(b,"showToast",[String(d)]).start()},setUrlParam:function(d,e){d!==""&&require("Task").create(c.getUrlParam(d)).then(function(g){e=encodeURIComponent(e);var f=a.pageParams;g?f=f.replace(new RegExp("([?#&]"+d+"=)([^#&]*)","i"),"$1"+e):f+="&"+d+"="+e;a.pageParams=f;require("Notify").pull(b,"setParams",[f]).start()}).start()},setAllowCallBackEvent:function(d){require("Notify").pull(b,"setAllowCallBackEvent",[d?1:0],{immediately:true}).start()},goToDetailPage:function(d){var e={url:d.url,appid:d.appid,apkId:d.apkId,myAppId:d.myAppId,packageName:d.pName,via:d.via,versionCode:d.versionCode,isAutoDownload:d.isAutoDownload,isAutoInstall:d.isAutoInstall};e=require("$").stringify(e);require("Notify").pull(b,"goToDetailPage",[e,""+(d.toMyApp||1)],{immediately:true}).start()},clearCache:function(){require("Notify").pull(require("Config").http,"clearWebViewCache").start()},getMinClientWidth:function(){return require("Task").create(require("Api").get("Display")).then(function(d){var e=require("Const");if(!e.minClientWidth){var d=d.split("x");e.minClientWidth=Math.min(d[0],d[1])/(d[0]/document.body.clientWidth)}return e.minClientWidth})},setActionButton:function(d){d=require("Util").extend({iconType:"0",visible:"1",callBackKey:"onSubBtn"},d);require("Notify").pull(b,"setActionButton",d).start()},changeLoadingTip:function(d){require("Notify").pull(b,"changeLoadingTip",[d==true?"1":"0"],{immediately:1}).start()},checkUpdate:function(){require("Notify").pull(b,"checkUpdateRes",[],{immediately:1}).start()}};return c});define("App",function(){var a=require("Config").app,b={idCache:{},pNameCache:{},dfData:{},add:function(c){var e=require("Util"),f=require("$"),d=require("LocalStorage");c=[].concat(c);e.each(c,function(g){var i="appinfo_"+g.id,h=d.get(i);h=h?f.parseJSON(h):{};e.each(g,function(j,k){j&&(h[k]=j)});d.set("appinfo_"+g.id,f.stringify(h));d.set("appinfo_pName_map_"+g.pName,g.id)})},_saveCache:function(c){this.idCache[c.id]=c;this.pNameCache[c.pName]=c},getAppById:function(d){var c=this.getAppsByIds(d);return c.length&&c[0]||null},getAppByPName:function(d,g){if(this.pNameCache[d]){return this.pNameCache[d]}var e=require("LocalStorage"),f=e.get("appinfo_pName_map_"+d),c=f&&e.get("appinfo_"+f)||"";c=c?require("$").parseJSON(c):null;c&&c.id&&this._saveCache(c);return c},getAppsByIds:function(c){var f=require("Util"),g=require("LocalStorage"),d=[],e=this;c=[].concat(c);f.each(c,function(i){if(e.idCache[i]){d.push(e.idCache[i])}else{var h=g.get("appinfo_"+i);h=h?require("$").parseJSON(h):{};h.id&&(e._saveCache(h),d.push(h))}});return d},getAppsByCate:function(c,d,e,f){return require("Task").create(require("Category").getCategory(c,d,e)).then(function(g){return g.length>0?b.getAppsByIds(g,f):[]}).then(function(g){return g})},getInstalledApp:function(){return require("Task").create(require("Notify").pull(a,"getAllDownAppInfo",[false,false,false])).then(function(c){return c?require("$").parseJSON(c):[]})},getAppInfo:function(c){c=[].concat(c);return require("Task").create(require("Notify").pull(a,"getAppInfoBatch",[c.join(","),",",false,false,false])).then(function(d){d=d&&require("$").parseJSON(d)||[];return c.length==1?d[0]||[]:d})},isInstall:function(c){c=[].concat(c);return require("Task").create(require("Notify").pull(require("Config").client,"appIsExistsBatch",[c.join(","),","])).then(function(d){return c.length==1?d=="1":d})},unInstallApp:function(d,c){c&&require("Notify").pull(a,"uninstallApp",[c]).start()},startApp:function(n){var c=n||{};c.tyqtype+="";c.appid+="";var i=require("Channel"),j=require("Via"),g=require("Const"),h,e,l,k,f=c.channelId,d=function(){require("Update").userAddApp(c.appid);require("Category").changeRecentPlay(c.appid);require("Event").fire("startApp",h)},m=function(){var o=require("Notify"),p=require("Config").client;switch(c.tyqtype){case"0":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;case"1":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||g.app_custom],{immediately:true}).start();d();break;case"2":o.pull(p,"startAppWithData",[c.pName,c.appurl],{immediately:true}).start();d();break;case"3":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||g.app_custom],{immediately:true}).start();d();break;case"4":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;case"5":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||g.app_custom],{immediately:true}).start();d();break;case"6":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;case"7":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||g.app_custom],{immediately:true}).start();d();break;case"8":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;default:o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();break}};require("Task").create().map({app:b.getAppById(c.appid),via:j.getModuleVia(f),channelVia:j.getChannelVia(f)}).then(function(o){h=o.app||{},e=o.via,l=o.channelVia;c.via&&f==i.OUTSIDE&&(o.via=o.via+c.via,o.channelVia=o.channelVia+c.via);e=f==i.HOMESOCIAL?e+"."+c.rank:e;k=(i.DETAIL==require("Const").channelId?l:e)+j.getSourceVia(c.appid,f);c.pName&&(h.ieg_ticket?(require("Notify").pull(require("Config").qqApi,"launchAppWithTokens",[c.appid,h.ieg_ticket,c.pName,"0"]).then(function(){},function(p){p.r==1&&m()}).start(),d()):m());!c.isAutoStart?require("Stat").startApp(k,c.appid):require("Stat").autoStartApp(k,c.appid)}).start()},goWebApp:function(i){var d=i||{};d.tyqtype+="";var h=require("Channel"),f=require("Via"),j,k,l,g,e=d.channelId,c=d.appid+="";d.appurl?require("Task").create().map({app:b.getAppById(c),via:f.getModuleVia(e),channelVia:f.getChannelVia(e)}).then(function(p){var m=p.app,n=p.via,r=p.channelVia,o=m.sourcetype==2,q=o?1==m.quickbar?1:0:1;n=e==h.HOMESOCIAL?n+"."+d.rank:n;g=(h.DETAIL==require("Const").channelId?r:n)+f.getSourceVia(c,e);!d.isAutoStart?require("Stat").startApp(g,c):require("Stat").autoStartApp(g,c);require("Update").userAddApp(c);require("Category").changeRecentPlay(c);require("Notify").pull(require("Config").client,"goWebApp",{appid:c,webviewConfig:o?m.webviewConfig||255:-1,args:d.webargs||"",strUrl:d.appurl,type:o?1:0,showQuickBar:q,screenOrientation:m.orientation||0,fullScreen:q?0:1,showDialog:o?1==m.isGenIcon?1:0:0,appName:m.name,appIconUrl:require("ImgCache").getPrefix(c)+"/"+c+"_100_m.png"},{immediately:true}).start();require("Event").fire("startApp",m)}).start():require("Api").showMsg("应用地址为空，启动应用失败")},getRecentApp:function(){var c=require("LocalStorage").get("latest_num")||10;return require("Notify").pull(a,"getRecentApp",[c])},getAppVersionCode:function(c,d,e){return require("Task").create(require("Notify").pull(require("Config").client,"getAppVersionCode",{packageName:d,appid:c,downloadUrl:e})).then(function(f){f&&(f=require("$").parseJSON(f.replace(/\s+/g,"")));return f})},getAppVersionCodeBatch:function(c){if(require("Type").isArray(c)&&c.length){var d=require("$");return require("Task").create(require("Notify").pull(require("Config").client,"getAppVersionCodeBatch",d.stringify(c))).then(function(e){return e&&d.parseJSON(e)})}else{return[]}},getScanSetting:function(){return require("Notify").pull(require("Config").app,"gSetPackageScanSetting","2",{immediately:true})},setScanSetting:function(c){return require("Notify").pull(require("Config").app,"gSetPackageScanSetting",String(c),{immediately:true})}};return b});define("AppUpdateData",function(){var a={data:{},map:{},check:function(b){b=[].concat(b);b.length&&require("Task").create(require("Notify").pull(require("Config").download,"checkUpdate",{packageNames:b})).then(function(c){c=require("$").parseJSON(c);a.data=c;require("Util").each(c,function(d){d.packageName&&(a.map[d.packageName]=d)})}).start()},getByPName:function(b){return a.map[b]||""}};return a});define("AsyncInterface",function(){var d=require("Events").eventEmitter,a=new d(),b=0,c=location.pathname.slice(location.pathname.lastIndexOf("/")+1)+"_",e={evt:a,add:function(f,g){++b;a.on(c+f+"_"+b,g);return b},emit:function(f,g,h){a.emit.call(a,c+f+"_"+g,h)},up:function(){return++b}};return e});define("Collector",function(){var b=require("Events").eventEmitter,a=function(c,d){this.time=c||1e3;this.count=d||10;this.timer=null;this.pool=[];this.evt=new b()};a.prototype={push:function(c){var d=this;this.pool.push(c);!this.timer&&(this.timer=setTimeout(function(){d.fulled()},this.time));this.pool.length>this.count&&this.fulled()},fulled:function(){this.timer&&(this.timer=clearTimeout(this.timer));this.evt.emit("fulled",this.pool.splice(0))},on:function(){this.evt.on.apply(this.evt,arguments)}};return a});define("Category",function(){var a={id:{home:"home_",boutique:"boutique_",appmainrank:"appmainrank_",apppopularrank:"apppopularrank_",latest_used_app:"latest_used_app",myapplist_v2:"myapplist_v2_",myapp_pc:"myapp_pc_",updateapp:"updateapp_",notify:"notify_",def_home:"def_home",def_guess:"def_guess"},cate:{},cateNext:null,getCategory:function(d,e,c){var b;c=c||require("Update").pageSize;var f=function(){b=[].concat(b);if(e){var g=Math.max(0,e-1)*c,h=Math.min(b.length,g+c);return b.slice(g,h)}else{return b}};return require("Task").create(require("Api").get("Uin")).then(function(g){var h=this;d+=g;b=a.cate[d];!b&&(b=require("$").parseJSON(require("LocalStorage").get(d))||[]);return f()})},getCateNext:function(b,c){c+="";if(!this.cateNext){return require("Task").create().map({uin:require("Api").get("Uin"),cateNext:require("Storage").getItem("cateNext")}).then(function(d){b+=d.uin;a.cateNext=require("$").parseJSON(d.cateNext)||{};!a.cateNext[b]&&(a.cateNext[b]={});return a.cateNext[b][c]||false})}else{return require("Task").create(require("Api").get("Uin")).then(function(d){b+=d;!a.cateNext[b]&&(a.cateNext[b]={});return a.cateNext[b][c]||false})}},setCateNext:function(b,c,d){c+="";require("Task").create(require("Api").get("Uin")).then(function(e){b+=e;!a.cateNext[b]&&(a.cateNext[b]={});a.cateNext[b][c]=d;require("Storage").setItem("cateNext",require("$").stringify(a.cateNext))}).start()},addIntoCategory:function(b,c,d){require("Task").create(this.getCategory(b)).then(function(e){e&&(e=require("Util").addToArray(e,c,d),a.setCategory(b,e))}).start()},removeFromCategory:function(b,c){require("Task").create(this.getCategory(b)).then(function(d){d.length&&(d=require("Util").removeFromArray(d,c),a.setCategory(b,d))}).start()},setCategory:function(b,c){c&&require("Task").create(require("Api").get("Uin")).then(function(d){b+=d;a.cate[b]=c;require("LocalStorage").set(b,require("$").stringify(c))}).start()},changeRecentPlay:function(b){require("Task").create().map({cate:this.getCategory(this.id.latest_used_app),pcapps:this.getCategory(this.id.myapp_pc)}).then(function(d){b=parseInt(b);var c=d.cate,e=d.pcapps;c=require("Util").removeFromArray(c,b);c.splice(e.length,0,b);a.setCategory(a.id.latest_used_app,c)}).start()}};return a});define("Download",function(){var b=require("Config").download,c=require("Events").eventEmitter,a={YYBAPPID:"1101070898",YYBPNAME:"com.tencent.android.qqdownloader",STATE:{ALL:0,INIT:1,DOWN:2,PAUSE:3,DOWN_END:4,SETUP:5,SETUP_END:6,SETUP_END_UPDATEPROSTATE:100,UNINSTALL_END:9,CANCEL:10,UPDATE:12,PACKAGE_REPLACE:13,WAIT:20,ERROR_SYSTEM:-1,ERROR_DOWN_EXCEPTION:-2,ERROR_SD_UNMOUNT:-3,ERROR_URL_CHANGE:-4,ERROR_NET_ERROR:-5,ERROR_SD_NOSPACE:-6},PSTATE:{DEFAULT:0,INSTALL:1,UNINSTALL:2},evt:new c(),downData:{},_proCache:{},init:function(){require("Event").on("loadProcess",function(){a.nativeCallback.apply(a,arguments)});this.addListener(this.STATE.UNINSTALL_END,function(d){d.appid&&a.updateProState(d.appid,a.PSTATE.UNINSTALL)});this.addListener(this.STATE.SETUP_END_UPDATEPROSTATE,function(e){var d=e.appid;d&&(a.updateProState(d,a.PSTATE.INSTALL,true),require("Task").create(require("App").getAppById(d)).then(function(f){f&&/^[23456]$/.test(f.tyqtype)&&(require("Update").userAddApp(d,undefined,"install"),require("Category").changeRecentPlay(d))}).start())})},addListener:function(d,e){this.evt.on(d,e)},notify:function(e,f,g){var d=g||{};this.evt.emit(e,d.overwrite||this.downData[f],d.isQuery)},nativeCallback:function(d){var g=this;try{if(require("Type").isArray(d)){require("Util").each(d,function(e){g.nativeCallback(e)})}else{var f=d.appid,h=d.packagename;if(h&&!f){var i=function(){f&&d.state&&g.downCallback({appid:f,pro:0,state:d.state,phony_pro:0})};!f?require("Task").create(require("App").getAppByPName(h)).then(function(e){e&&(f=e.id)&&i()}).start():i()}else{g.downCallback(d)}}}catch(j){}},overwriteDownData:function(d){this.downData[d.appid]=d},downCallback:function(d,e){this.downData[d.appid]=d;this.notify(d.state,d.appid,{isQuery:e});this.notify(this.STATE.ALL,d.appid,{isQuery:e});this.STATE.SETUP_END==d.state&&this.notify(this.STATE.SETUP_END_UPDATEPROSTATE,d.appid,{isQuery:e})},getProState:function(d){return this._proCache[d]||0},updateProState:function(d,e,f){var g=this._proCache[d]||0;this.PSTATE.UNINSTALL==e&&!f&&require("Task").create(this.query(d,{needRet:true})).then(function(h){h&&!h[0]&&g==1&&a.notify(a.STATE.UNINSTALL_END,d,{overwrite:{appid:d,pro:0,state:a.STATE.UNINSTALL_END,phony_pro:0}})}).start();this._proCache[d]=e},query:function(d,g){var h=this,e=g||{};d=[].concat(d);if(d.length){var f=require("Task").create(!e.focus?require("App").getAppsByIds(d):d).then(function(j){var i=[];require("Util").each(j,function(k){i.push({appid:k.id,myAppId:k.appid_haina||k.myAppId||"",apkId:k.apkId||"",packageName:k.pName,versionCode:k.versionCode})});return require("Notify").pull(b,"getQueryDownloadAction",[require("$").stringify(i)])}).then(function(i){!e.quite&&require("Util").each(i,function(j){h.downCallback(j,true)});return i});return e.needRet?f:f.start()}else{return[]}},cancelNotification:function(d,e){d&&require("Notify").pull(b,"cancelNotification",["_"+d]).start();e&&require("Notify").pull(b,"cancelNotification",[""+e]).start()},cancel:function(d){require("Notify").pull(b,"cancelDownload",[""+d,"_"+d]).start()},go:function(u){var m=require("Const"),n=require("App"),h=require("Via"),i=require("Channel"),e=this.STATE,p=null,q=null,j=null,v=null,r=null,s=null,d=u||{},g=d.channelId,t=d.overWriteState||"",w=d.pcpush?"1":"0",f=this.downData[d.appid]||"",k="",l=function(o){o!=e.SETUP&&(f.state=o);var y={myAppConfig:d.pName=="com.tencent.android.qqdownloader"?0:d.myAppConfig,appid:d.appid+"",url:d.appurl,packageName:d.pName,actionCode:o,via:s?msgVia:r?q:p,appName:j&&j.name||d.appName||"",notifyKey:"N_"+d.appid,updateData:require("AppUpdateData").getByPName(d.pName)||"",updateType:0,myAppId:parseInt(d.myAppId,10)==0?"":d.myAppId,apkId:parseInt(d.apkId,10)==0?"":d.apkId,versionCode:d.versionCode,isAutoDownload:"1",isAutoInstall:"1",toPageType:d.toPageType,showNetworkDialog:w,wording:d.wording||"",channel:d.channel||""};require("Notify").pull(b,"doDownloadAction",y,{immediately:true}).start()},x=function(){!f&&(f={appid:d.appid,pro:0,state:e.INIT,phony_pro:0},a.downData[d.appid]=f);f.state=Math.max(1,f.state);t&&(f.state=t);switch(f.state){case e.INIT:k=d.isUpdate?e.UPDATE:e.DOWN;a.notify(e.INIT,d.appid);case e.PAUSE:case e.UPDATE:case e.UNINSTALL_END:case e.CANCEL:l(k||e.DOWN);a.notify(k||e.DOWN,d.appid);break;case e.WAIT:case e.DOWN:l(e.PAUSE);a.notify(e.PAUSE,d.appid);break;case e.DOWN_END:l(e.SETUP);a.notify(e.SETUP,d.appid);break;case e.SETUP_END:a.notify(e.SETUP_END,d.appid);return"isInstalled"}return false};return require("Task").create().map({via:h.getModuleVia(g),channelVia:h.getChannelVia(g),msgVia:h.getMsgVia(g),appInfo:n.getAppById(Math.abs(d.appid)),isInstall:d.isInstall!=undefined?d.isInstall:n.isInstall(d.pName)}).then(function(o){d.via&&g==i.OUTSIDE&&(o.via=o.via+d.via,o.channelVia=o.channelVia+d.via);p=o.via+(g==i.HOMESOCIAL?"."+d.rank:"")+h.getSourceVia(d.appid,g);q=o.channelVia+h.getSourceVia(d.appid,g);msgVia=o.msgVia;j=o.appInfo;v=o.isInstall;r=i.DETAIL==m.channelId;s=i.ASSISTANT==m.channelId;if(!d.focus&&!j){return true}return x()})}};a.init();return a});define("Event",function(){var b=require("Events").eventEmitter,a=new b();a.fire=function(){var m=require("Util"),f=String(arguments[0]);if(f.indexOf(".")>-1){f=f.split(".");var g=f[0],h=f[1],i=function(n,o,p,q){require("M").stringReport({errMsg:n,code:o,duration:p,reportRate:q||0})};switch(g){case"interface":var k=require("Type"),l=require("$"),d=arguments[1];k.isString(d)&&(d=l.parseJSON(d));if(d&&d.guid){var j=d.guid,e=require("Notify").getDuration(j);e=Date.now()-e;e>500&&i("namespace [ "+g+" ] notify method [ "+h+" ] Native call Time-consuming!",-430,e,1e4);d.r==-1&&i("namespace [ "+g+" ] notify method [ "+h+" ] Native call cause Error!",d.r,e);d.r==-2&&i("namespace [ "+g+" ] notify method [ "+h+" ] No Such Method!",d.r,e)}require("AsyncInterface").emit(h,j,d);break}}else{this.emit.apply(this,arguments)}};var c=require("QzoneApp");c.fire=function(){a.fire.apply(a,arguments)};return a});define("Http",function(){var c=require("Config").http,a={guid:0,pool:{},_reqcallback:function(d,e){var g=this.pool[d.guid]||{},e=g[e],f=d.content?require("$").parseJSON(d.content.replace(/;$/,"")):{};d.extend&&(f=require("Util").extend(f,d.extend));e&&e.call(null,f,d.guid)},onError:function(d){d&&this._reqcallback(d,"error");var e=require("Api");require("Task").create(e.get("APNType",true)).then(function(f){e.showMsg(f>0?"服务器请求失败，请重试":"网络无连接")}).start()},onSuccess:function(d){d&&this._reqcallback(d,"success")},serializeParam:function(d){var f=require("Api"),e=null;return require("Task").create(f.getMobileInfo()).map(function(g){e=g;return{version:require("M").JSVersion||"0",from_h5:1}}).then(function(h){var i=require("Util"),g=[];d=i.extend(d,h);d.os_api_level=e.os_api_level;d.os_ver=e.os_ver;require("Util").each(d,function(j,k){g.push(k+"="+encodeURIComponent(j))});g=g.join("&");return g})},_send:function(d,e){require("Task").create(require("Api").get("Sid")).then(function(f){if(!f){a.onError({guid:d.guid,msg:"sid is Null"});return}var g=e.isGetUpdateApp?require("Config").app:c,h=e.isGetUpdateApp?"getUpdateApp":"httpRequest";require("Notify").pull(g,h,d).start()}).start()},loadJson:function(e){var d=e,f=d.id=++a.guid;this.pool[f]=d;require("Task").create(this.serializeParam(d.param)).then(function(g){d.url+=(d.url.indexOf("?")>-1?"&":"?")+g;a._send({guid:f,method:"GET",url:d.url,supportetag:0==e.supportetag?0:1},e)}).start();return f},formSubmit:function(e){var d=e,f=d.id=++a.guid;this.pool[f]=d;require("Task").create(this.serializeParam(d.param)).then(function(g){a._send({guid:f,method:"POST",url:d.url,params:d.param,supportetag:0==e.supportetag?0:1},e)}).start();return f}},b=require("Event");b.on("httpSuccess",function(){a.onSuccess.apply(a,arguments)});b.on("httpError",function(){a.onError.apply(a,arguments)});return a});define("Xhr",function(){function a(d){var e=d.url,b=new XMLHttpRequest(),c=d.type||"get",f=d.callback||function(){};c=c.toLowerCase();b.onload=function(h){var g=b.responseText||"";try{g.substr(-1)==";"&&(g=g.substr(0,g.length-1));g=JSON.parse(g)}catch(h){}f(g)};b.ontimeout=b.onerror=function(g){f({type:g.type,code:b.status})};require("Task").create(require("Http").serializeParam(d.data||{})).then(function(g){"get"===c&&g!=""&&(e+=e.indexOf("?")>=0?"&"+g:"?"+g);var h="get"===c?null:g;b.open(c,e,d.async||true);"post"===c&&b.setRequestHeader("Content-Type","application/x-www-form-urlencoded");b.send(h)}).start()}return{send:a}});define("ImgCache",function(){var a={getPrefix:function(b){return["http://i.gtimg.cn/open/app_icon/",("00000000"+b).substr(-8).match(/\d{2}/g).join("/")].join("")},getPicTmpl:function(b){b=b||{};var c="";switch(b.type.toLowerCase()){case"logo":var d=b.picid+"_100_m.png";c=a.tmpl.logo({src:!b.force?a.getPrefix(b.picid)+"/"+d:b.src,picid:b.picid,picname:d,className:b.className||"",loadDef:b.loadDef?1:0,lazyload:b.lazyload==false?false:true});break;case"preview":c=a.tmpl.preview({src:a.getPrefix(b.picid)+"/"+b.picname,picid:b.picid,picname:b.picname,extendAttr:b.extendAttr||""});break;case"ad":c=a.tmpl.ad({src:b.picurl,picid:b.picid,picurl:b.picurl,extendAttr:b.extendAttr||""});break}return c}};a.tmpl={};a.tmpl.logo=function(c){with(c||{}){var b=[],d=!loadDef&&lazyload?" data-inview='imgLazyLoad' _ori_src='"+src+"' ":"";b.push('<img pictype="LOGO" src="');b.push(loadDef||lazyload?"qapp_center_defaultlogo.png":src);b.push('" ');b.push(d);b.push(' onerror="this.src=\'qapp_center_defaultlogo.png\';" picid="');b.push(picid);b.push('" loadDef="');b.push(loadDef);b.push('" picname="');b.push(picname);b.push('" class="');b.push(className);b.push(' j_for_switch_mode j_for_render_pic">');return b.join("")}};a.tmpl.preview=function(c){with(c||{}){var b=[];b.push('<img pictype="PREVIEW" src="');b.push(src);b.push('" picid="');b.push(picid);b.push('" picname="');b.push(picname);b.push('" onerror="this.style.visibility=\'hidden\';" class="j_for_switch_mode j_for_render_pic" ');b.push(extendAttr);b.push(">");return b.join("")}};a.tmpl.ad=function(c){with(c||{}){var b=[];b.push('<img pictype="AD" src="');b.push(src);b.push('" onerror="this.src=\'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAUAAAAB9AQMAAADpzSguAAAAA1BMVEXx8fJNaGfxAAAAG0lEQVRYw+3BAQ0AAADCIPuntscHDAAAAABoOxQFAAF3OMnVAAAAAElFTkSuQmCC\';" picid="');b.push(picid);b.push('" picurl="');b.push(picurl);b.push('" class="j_for_render_pic" ');b.push(extendAttr);b.push(">");return b.join("")}};return a});define("Stat",function(){var b=require("Collector"),c=new b(2e3,10),d=new b(3e3,10),e="http://analy.qq.com/cgi-bin/mapp_apptrace?",a={reportBatch:function(f){setTimeout(function(){require("Notify").pull(require("Config").client,"reportForViaBatch",[require("$").stringify(f)]).start()},0)},sendByJsBatch:function(f){var g=require("Api"),h=[];require("Task").create().map({uin:g.get("Uin"),mobileInfo:g.get("MobileInfo")}).then(function(j){var i=j.mobileInfo,k={jsversion:require("M").JSVersion||"0",qua:i.qua,platform:i.platform,os_ver:i.os_ver,imei:i.imei,uin:j.uin,resolution:i.resolution,qz_ver:i.qz_ver,sdk_ver:"1.5",model_name:i.model_name,lang:i.language||"",network:i.network,ret_code:0,timezone:i.timezone,wifimac:i.wifimac,device:i.device,action:100,longitude:i.location||"",mobile_pf:1,appid_via_act_net_time_sender:f.join(",")};require("Util").each(k,function(l,m){h.push(m+"="+encodeURIComponent(l))});f&&f.length>0&&require("PingSender").send(e+h.join("&"))}).start()},sendByJs:function(f,g,h){d.push([h,g,f,require("Api").getMobileInfo().network,new Date().getTime(),0].join("_"))},send:function(g,h,i,f){f=f||{};c.push({actionType:g,via:h,appid:(i||require("Const").appid)+"",packageName:f.packageName||"",channel:f.channel||"",jsversion:require("M").JSVersion||"0"})},exposure:function(f,g,i,h){i?this.sendByJs("100",f,g,h):this.send("100",f,g,h)},click:function(f,g,h){this.send("200",f,g,h)},setup:function(f,g,h){this.send("300",f,g,h)},setupWebApp:function(f,g){setTimeout(function(){require("Notify").pull(require("Config").client,"reportStartApp",{via:f,appid:g+"",jsversion:require("M").JSVersion||"0",sender:0}).start()},50)},startApp:function(f,g,h){this.send("500",f,g,h)},autoStartApp:function(f,g,h){this.send("502",f,g,h)},cancelClick:function(f,g,h){this.send("700",f,g,h)},download:function(f,g,h){this.send("900",f,g,h)},unInstall:function(f,g,h){this.send("1000",f,g,h)},update:function(f,g,h){this.send("2000",f,g,h)}};c.on("fulled",a.reportBatch);d.on("fulled",a.sendByJsBatch);return a});define("Storage",function(){var b=require("Database"),a={getItem:function(c){return require("LocalStorage").get(c)},setItem:function(c,d){require("LocalStorage").set(c,d)}};return a});define("StorageMap",{appupdate_count:"appupdate_count_",message:"message_",need_new:"need_new_",finish_guide:"finish_guide_",social_max_count:"social_max_count_",myNotifyCount:"myNotifyCount_"});define("Update",function(){var b="http://mapp.qzone.qq.com",a={url:b+"/cgi-bin/mapp/mapp_data",infourl:b+"/cgi-bin/mapp/mapp_info",privacyurl:b+"/cgi-bin/mapp/mapp_privacy",urlMap:{home:b+"/cgi-bin/mapp/mapp_home_qq",latest_used_app:b+"/cgi-bin/mapp/mapp_latest_used_app",boutique:b+"/cgi-bin/mapp/mapp_cate_qq",appmainrank:b+"/cgi-bin/mapp/mapp_applist?apptype=soft_top",apppopularrank:b+"/cgi-bin/mapp/mapp_applist?apptype=soft_pop",myapplist_v2:b+"/cgi-bin/mapp/mapp_mylist_qq",report:b+"/cgi-bin/mapp/mapp_report",topic:"http://mapp.qzone.qq.com/cgi-bin/mapp/mapp_topic"},updateTime:null,LOADLOCALDATA:true,BYDAY:false,CACHETIME:1e3*60*30,MSG_CACHETIME:1e3*60*2,TOPIC_IDS:["essential_indexTopic","hot_indexTopic","recmdUpdate_recmdUpdate"],RELATIONPREFIX:"relationprefix",KEY:{home:"home",rec:"recommend",indexadv:"indexadvs",topic:"topic",boutique:"boutique",appmainrank:"appmainrank",apppopularrank:"apppopularrank",latestUsedApp:"latest_used_app",myapp:"myapplist",myapp_v2:"myapplist_v2",notify:"notify",message:"message"},needRefresh:false,retKey:{apps:"app",social:"social",advs:"advs",notify:"notify",message_count:"message_count",appupdate_count:"appupdate_count",latestUsedApp:"latestUsedApp",updateapp:"updateapp",reportRate:"reportRate"},page:{},pageSize:20,getUpdateTime:function(){if(!this.updateTime){return require("Task").create(require("Storage").getItem("dataUpdateTime")).then(function(c){c=c?require("$").parseJSON(c):{};a.updateTime=c;return c})}return this.updateTime},saveUpdateTime:function(){require("Storage").setItem("dataUpdateTime",require("$").stringify(this.updateTime))},isNeedUpdate:function(c,e){if(c==a.KEY.myapp_v2||c==a.KEY.topic&&a.topicId==a.TOPIC_IDS[2]){return 1}e=e||1;var d=this,f=this.KEY.message==c?this.MSG_CACHETIME:this.CACHETIME;return require("Task").create(this._resetKey(c)).then(function(g){!d.updateTime[g]&&(d.updateTime[g]={});var i=new Date(d.updateTime[g][e]||0),j=new Date(),h=0,k=function(l){return l.getFullYear()+"-"+(l.getMonth()+1)+"-"+l.getDate()},h=j>i&&j-i>d.CACHETIME?1:0;return h})},setUpdateTime:function(e,f,d){var c=this;require("Task").create(this._resetKey(e)).then(function(g){!c.updateTime[g]&&(c.updateTime[g]={});c.updateTime[g][f]=d&&d*1e3||Date.now()}).start()},_resetKey:function(c){return require("Task").create(require("Api").get("Uin")).then(function(e){var d=a.KEY,f=c;c=(new RegExp("^("+d.indexadv+"|"+d.gamelistadv+"|"+d.nogamelistadv+")$")).test(c)?c:c+"_"+e;c=f==d.topic?c+"_"+a.topicId:c;return c})},_updateCategoryRelationData:function(h,e,d,f,c,g,i){c=this.RELATIONPREFIX+c;require("Task").create(require("Category").getCategory(c)).then(function(k){var l=a.KEY,n=require("Category").id,j=[];f=f,len=e&&e.length||0;if(len>0||g&&d==1){l.topic==h&&require("Util").each(e,function(o){o&&j.push({id:o.id,columnid:o.columnid,columnname:o.columnname})});if(g){require("Category").setCategory(c,j)}else{var m=Math.max(0,d-1)*f;Array.prototype.splice.apply(k,[m,len].concat(j));require("Category").setCategory(c,k)}require("Category").setCateNext(c,d,i)}else{d==1&&(require("Category").setCategory(c,[]),require("Category").setCateNext(c,d,false))}}).start()},_updateCategoryData:function(d,f,g,e,h,i){var c=require("Category");require("Task").create(c.getCategory(e)).then(function(k){var n=c.id,j=d&&d.length||0,l=[];if(j>0||h&&f==1){require("App").add(d);require("Util").each(d,function(o){o&&l.push(o.id)});if(h){c.setCategory(e,l)}else{var m=Math.max(0,f-1)*g;j!=g&&(j=k.length-m);Array.prototype.splice.apply(k,[m,j].concat(l));c.setCategory(e,k)}c.setCateNext(e,f,i)}}).start()},_updateData:function(j,l,d,f,s){var t=require("Util"),m=require("$"),c={},n=this,h=this.retKey,g=this.KEY,q=require("Category").id,o="";t.each(h,function(e){c[e]=f[e]});var p=q[j],d=d||this.page[j];switch(j){case g.home:var k=c[h.apps]||[],i=c[h.advs]||[];this._updateCategoryData(k,d,l,p,c.overwrite,f.next);i.length>0&&(require("Storage").setItem(g.indexadv,m.stringify(i)),this.setUpdateTime(g.indexadv,1,f.time));this.setUpdateTime(j,d,f.time);break;case g.topic:var k=c[h.apps]||[],i=c[h.advs]||[];j==g.topic&&this.TOPIC_IDS.indexOf(this.topicId)>-1&&this._updateCategoryRelationData(j,k,d,l,p,this.TOPIC_IDS.indexOf(this.topicId)==2?true:c.overwrite,f.next);this._updateCategoryData(k,d,l,p,this.TOPIC_IDS.indexOf(this.topicId)==2?true:c.overwrite,f.next);!!o&&i.length>0&&(require("Storage").setItem(o,require("$").stringify(i)),this.setUpdateTime(o,1,f.time));this.setUpdateTime(j,d,f.time);break;case g.boutique:case g.appmainrank:case g.apppopularrank:var k=c[h.apps]||[],i=c[h.advs]||[];this._updateCategoryData(k,d,l,p,c.overwrite,f.next);i.length>0&&(require("Storage").setItem(o,m.stringify(i)),this.setUpdateTime(o,1,f.time));this.setUpdateTime(j,d,f.time);break;case g.latestUsedApp:var r=c[h.latestUsedApp]||[],u=[];d==1&&(c.overwrite=true,t.each(r,function(e){!!e.ismultipf&&u.push(e)}),this._updateCategoryData(u,d,l,q.myapp_pc,c.overwrite,f.next));this._updateCategoryData(r,d,l,p,c.overwrite,f.next);r.length>0&&this.setUpdateTime(j,d,f.time);break;case g.myapp_v2:var n=this,v=c[h.notify]||{update:[],pcapp:[]},w=c[h.message_count]||0,x=c[h.appupdate_count]||0;v&&!s.message_only&&(require("Task").create(require("Api").get("Uin")).then(function(e){require("Storage").setItem(q.notify+e,m.stringify(v))}).start(),n.setUpdateTime(g.notify,d,f.time));s.need_message&&(require("Task").create(require("Api").get("Uin")).then(function(e){require("Storage").setItem(require("StorageMap").message+e,m.stringify(w))}).start(),n.setUpdateTime(g.message,d,f.time));require("Task").create(require("Api").get("Uin")).then(function(e){require("Storage").setItem(require("StorageMap").appupdate_count+e,m.stringify(x));n.setUpdateTime(g.myapp_v2,d,f.time)}).start();a.resetUpdateTime4MyappAndUpdateApp(true);break}this.saveUpdateTime();if(c.reportRate){try{require("Task").create(require("Api").get("Uin")).then(function(e){window.localStorage&&localStorage.setItem("reportRate_"+e,encodeURIComponent(m.stringify(c.reportRate)))}).start()}catch(y){}require("M").stringReport.reportRate=parseInt(c.reportRate)}},getLocalData:function(g,m){var j=require("$"),k=require("App"),i=require("Category"),e=this.KEY,n=i.id,q=this,c={},f=n[g],d=m.pageNo,h=m.pageSize,r="",p={},o=false;c.dataVerify=true;var l=function(){!c.dataVerify&&q.saveUpdateTime();c.loadDefdata=o;return c};switch(g){case e.home:return require("Task").create().map({app:k.getAppsByCate(f,d,h,false),advs:require("Storage").getItem(e.indexadv),next:i.getCateNext(f,d)}).then(function(s){c.app=s.app||[];c.advs=j.parseJSON(s.advs)||[];c.next=s.next;c.app.length==0&&1==d&&(o=true,c.app=p.home||[]);0==c.advs.length&&(o=true,c.advs=p.indexadv||[]);(0==c.app.length||h!=c.app.length)&&(c.dataVerify=false,a.setUpdateTime(g,d,2649600));return l()});case e.boutique:case e.appmainrank:case e.apppopularrank:return require("Task").create().map({app:k.getAppsByCate(f,d,h,false),advs:require("Storage").getItem(e.indexadv),next:i.getCateNext(f,d)}).then(function(s){c.app=s.app||[];c.advs=j.parseJSON(s.advs)||[];c.next=s.next;0==c.app.length&&1==d&&(o=true,c.app=p[g]||[]);(0==c.app.length||h!=c.app.length)&&(c.dataVerify=false,a.setUpdateTime(g,d,2649600));return l()});case e.topic:return require("Task").create().map({app:k.getAppsByCate(f,d,h,true),next:i.getCateNext(f,d),cate:i.getCategory(a.RELATIONPREFIX+f)}).then(function(t){c.app=t.app||[];c.next=t.next;var u=t.cate||[];if(a.TOPIC_IDS.indexOf(a.topicId)>-1){var v=Math.max(0,d-1)*h;u=u.slice(v,v+h);for(var s=0;s<c.app.length;s++){c.app[s]=require("Util").extend(c.app[s],u[s]||{})}}0==c.app.length&&(c.dataVerify=false,a.setUpdateTime(g,d,2649600));return l()});case e.latestUsedApp:return require("Task").create(require("Api").get("Uin")).map(function(s){return{notify:require("Storage").getItem(n.notify+s),latestUsedApp:k.getAppsByCate(f,d,h),myappPc:k.getAppsByCate(n.myapp_pc),need:a.isNeedUpdate(g,d),next:i.getCateNext(f,d)}}).then(function(s){c.notify=j.parseJSON(s.notify)||{update:[],pcapp:[]};c.latestUsedApp=s.latestUsedApp||[];c.myappPc=s.myappPc||[];c.next=s.next;0==[].concat(c.latestUsedApp)&&s.need&&(c.dataVerify=false,a.setUpdateTime(g,d,2649600));return l()});case e.myapp_v2:return require("Task").create(require("Api").get("Uin")).map(function(s){return{notify:require("Storage").getItem(n.notify+s),appupdate_count:require("Storage").getItem(require("StorageMap").appupdate_count+s),message_count:m.need_message?require("Storage").getItem(require("StorageMap").message+s):0}}).then(function(s){c.notify=j.parseJSON(s.notify)||{update:[],pcapp:[]};m.need_message&&(c.message_count=j.parseJSON(s.message_count)||0);c.appupdate_count=s.appupdate_count;return l()})}},loadData:function(c,A){var t=require("$"),k=require("Util"),i=require("Task"),u=require("Api"),m=require("Category"),f=A||{},h=this,d=this.KEY,B=this.retKey,n=m.id,e=f.param||{},l=e.pageSize||this.pageSize,w=!!e.pageNo,r="",p=false,j=false,D=false,v=false,x=!!f.need_installApp;c==d.topic&&(n[c]=f.idKey,this.topicId=e.topic_id);!this.page[c]&&(this.page[c]=0);var g=e.pageNo||this.page[c]+1,s,q,C=e.need_message||0;i.create(this.getUpdateTime()).then(function(){if(d.myapp_v2==c&&e.notify_only){return i.create().map({myapp_v2:h.isNeedUpdate(d.myapp_v2,1),need_notify:h.isNeedUpdate(d.notify,1),need_message:e.need_message?h.isNeedUpdate(d.message,1):false}).then(function(o){!o.need_notify&&o.need_message&&(q=1);return o.need_notify||o.need_message||o.myapp_v2})}else{return h.isNeedUpdate(c,g)}}).map(function(o){s=o;return{need:s,mobileInfo:u.getMobileInfo()}}).then(function(E){e=k.extend({type:c,pageNo:g,pageSize:l,need_advertise:d.home==c?1:0},f.param);if(d.home==c||d.topic==c){var o=E.mobileInfo;e=k.extend({imei:o.imei,mac_addr:o.wifimac,model_info:o.model_name||"",network_type:o.network||"",network_operater:o.mobileType||"",location:o.location||"",imsi:o.imsi||"",android_id:o.androidID||"",os_api_level:o.os_api_level||""},e)}i.create(z()).then(function(F){(v||F&&s)&&y()}).start()}).start();var y=function(){if(p){return}p=true;var H=false;e.firsttime=0;switch(c){case d.rec:case d.home:r=d.indexadv;e.need_friends=1;break;case d.boutique:case d.appmainrank:case d.apppopularrank:break;case d.latestUsedApp:case d.myapp:case d.myapp_v2:break}var E=function(I){if(0==I.resultCode){var P=require("App"),K=require("Storage"),Q=require("StorageMap"),M,N,O,L=[];i.create().map({uin:u.get("Uin"),oldList:m.getCategory(n[c],g,l),oldAdvs:1===e.need_advertise&&r&&K.getItem(r),notify_resetKey:h._resetKey(d.notify)}).then(function(R){M=R.oldList;O=R.notify_resetKey;N=t.parseJSON(R.oldAdvs)||[];!w&&(h.page[c]=g);d.home==c&&g==1&&(I.social=I.social||[],I.app=I.social.concat(I.app),K.setItem(Q.social_max_count+R.uin,I.social.length));h._updateData(c,l,g,I,{message_only:q,need_message:C});if(1===e.need_advertise&&r){if(!I.advs){I.advs=N}else{if(d.home==c){var S=[],T=[];k.each(N,function(V){S.push(V.advId+"_"+(V.img&&V.img.medium)+"_"+V.trace_id)});k.each(I.advs,function(V){T.push(V.advId+"_"+(V.img&&V.img.medium)+"_"+V.trace_id)});S=S.join(",");T=T.join(",");S!==T&&(I.overwrite=1,I.pageNo=g,j=false)}}}if(d.myapp_v2==c&&e.notify_only){j=false;i.create(q&&K.getItem(O)).then(function(V){q&&(I.notify=V&&t.parseJSON(V)||{update:[],pcapp:[]});J()}).start();I.latest_num&&require("LocalStorage").set("latest_num",I.latest_num)}else if(d.latestUsedApp==c){i.create(K.getItem(O)).then(function(X){I.notify=t.parseJSON(X)||{};var V=I[B.latestUsedApp],W=[];k.each(V,function(Y){Y.id&&L.push(Y.id);!!Y.ismultipf&&W.push(Y)});g==1&&(I.myappPc=W);M.join(",")!=L.join(",")?(u.setUrlParam("refresh","0"),I.overwrite=1,I.pageNo=g,j=false,g>1?i.create(m.getCategory(n[c])).then(function(Y){Y=Y.slice(0,Math.max(0,g-1)*l);return P.getAppsByIds(Y)}).then(function(Y){I.latestUsedApp=Y.concat(V);J()}).start():J()):J()}).start();I.latest_num&&require("LocalStorage").set("latest_num",I.latest_num)}else{d.home==c&&K.setItem(Q.need_new+R.uin,1);var U=I.app;k.each(U,function(V){V.id&&L.push(V.id)});I.giftcenterurl&&require("LocalStorage").set("giftcenterurl",I.giftcenterurl);M.join(",")!=L.join(",")||v?(I.overwrite=1,I.pageNo=g,j=false,g>1?i.create(m.getCategory(n[c])).then(function(V){V=V.slice(0,Math.max(0,g-1)*l);V=require("Util").removeFromArray(V,L);return P.getAppsByIds(V)}).then(function(V){if(a.TOPIC_IDS.indexOf(a.topicId)>-1){return i.create(m.getCategory(a.RELATIONPREFIX+n[c])).then(function(X){X=(X||[]).slice(0,Math.max(0,g-1)*l);for(var W=0,Y=V.length;W<Y;W++){V[W]=k.extend(k.extend({},V[W]),X[W]||[])}return V})}else{return V}}).then(function(V){I.app=V.concat(U);J()}).start():J()):J();I.preload_layer&&require("LocalStorage").set("preload_layer",I.preload_layer)}}).start();var J=function(){h.needRefresh&&(j=false);I.__isFromLocal=0;!j&&f.success&&f.success.call(null,I);j=true;p=false}}else{o(I);p=false}},o=function(I){I.__isFromLocal=0;!j&&(h.LOADLOCALDATA&&!f.errorFromLocal?(f.errorfromServer=true,z().start()):f.error&&f.error.call(null,I),j=true);p=false},F=e.url||h.urlMap[c];delete e.url;if(d.myapp_v2==c&&!q||d.latestUsedApp==c||x&&d.topic==c){var G=function(){require("Http").formSubmit({isGetUpdateApp:x,url:F,param:e,success:E,error:o})};e.update_data=0;G()}else{require("Http").loadJson({url:F,param:e,success:E,error:o})}},z=function(o){return i.create(h.getLocalData(c,e)).then(function(E){E.__isFromLocal=1;if(E.dataVerify){j=true;v=E.loadDefdata;!w&&(h.page[c]=g);f.success&&f.success.call(null,E,s);return true}else{!f.errorfromServer?(f.errorFromLocal=true,y()):f.error&&f.error.call(null,E);return false}})}},setPrivacyData:function(d,c){require("Http").formSubmit({url:this.privacyurl,param:{appid:d.id},success:function(e){0==e.resultCode?(d.friends.myprivacy=1,require("App").add(d),c.success&&c.success.call(null,e)):c.error&&c.error.call(null,e)},error:function(e){c.error&&c.error.call(null,e)}})},getAppFromServer:function(d,e){var f=require("Util"),c=e||{},g=f.extend({type:"appinfo",appid:d},c.param);d&&require("Http").loadJson({url:this.infourl,param:g,success:function(h){var i=require("App");0==h.resultCode?(require("Task").create(i.getAppById(d)).then(function(k){var j=h.app&&h.app[0]||{};k=k||{};h.friendsplayed&&(j.friends=h.friendsplayed[0]||{});j.id?(delete j.playCount,j.userCount=Math.max(j.userCount,k.userCount||0),!c.noDb?i.add(j):i._saveCache(j),c.success&&c.success.call(null,h)):(h.msg="找不到这个应用哦",require("M").stringReport({errMsg:"Api.update.getAppFromServer appid : "+d+" load error. the appinfo in result is illegal",code:-502,duration:0}),c.error&&c.error.call(null,h))}).start(),h.preload_layer&&require("LocalStorage").set("preload_layer",h.preload_layer)):c.error&&c.error.call(null,h)},error:function(h){c.error&&c.error.call(null,h)}})},userAddApp:function(c,e,d){if(c){e?require("Stat").setupWebApp(e,c):require("Task").create(require("Api").get("Uin")).map(function(f){return{uin:f,isReport:require("Storage").getItem("record_"+c+"_"+f)}}).then(function(f){if(d=="install"){if(f.isReport){return}else{require("Storage").setItem("record_"+c+"_"+f.uin,1)}}require("Http").loadJson({url:"http://mapp.qzone.qq.com/cgi-bin/mapp/mapp_report",param:{type:"latest_used_app",appid:c,action:d&&encodeURIComponent(d)||""},success:function(g){0==g.resultCode}})}).start();return true}else{return false}},resetUpdateTime4MyappAndUpdateApp:function(c){require("Task").create(a.getUpdateTime()).then(function(d){a.topicId=a.TOPIC_IDS[2];a.setUpdateTime(a.KEY.topic,1,2649600);!c&&a.setUpdateTime(a.KEY.myapp_v2,1,2649600);a.saveUpdateTime()}).start()}};return a});define("Init",function(){var a={start:function(){window.JsBridge=require("JsBridge");window.QzoneApp=require("QzoneApp");require(["DownloadBtn","TapEvent","BatchCallback","ActionBtn"]);if(require("Util").greaterThanOrEqual(require("Const").QQVer,"5.2")){var b=require("M");require("Task").create(require("Notify").pull(require("Config").client,"setCommonReportData",{jsversion:b.JSVersion,pageversion:b.PageVersion},{timeout:true})).then(function(c){}).start()}else{require("Task").create(require("Notify").pull(require("Config").client,"getPlatform",[],{timeout:true})).then(function(c){require("Const").Platform=c}).start()}require("Api").changeLoadingTip(false)}};return a});define("DownloadBtn",function(){var b=/HUAWEI U9508/i.test(navigator.userAgent),c=/ApiLevel\/1[456]/i.test(navigator.userAgent)&&/GT-I9300/i.test(navigator.userAgent),d=/\sM040\s/i.test(navigator.userAgent),e=/\sNX403A\s/i.test(navigator.userAgent),f=b||c||d||e,a={D_BTN:".pro_",D_PRO:" .d_pro",D_PRO_TEXT:" .d_pro_text",D_TEXT:" .d_text",D_STATE:" .d_state",D_SEARCH:" .d_search",D_COLOR_BTN:" .ui-btn",COLOR_BTN_START:"enter",COLOR_BTN_OTHER:"downing",CSS_SHOW_PRO:"show_pro",MSG:{"-1":"当前安装包出现问题或已被删除,请重新下载！","-2":"下载出错，请重试！","-3":"未发现存储卡，请检查后重试！","-4":"下载地址已更新,请重新下载！","-5":"网络无法连接，请检查网络并重试！","-6":"存储卡空间不足，请释放空间后重试！"},TEXT:{PAUSE:"下载中",FIRSTDOWNLOAD:"抢先下载",DOWNLOAD:"下载",CONTINUE:"继续",INSTALL:"安装",UPDATE:"更新",START:"进入",WAIT:"等待中"},SEARCH_BTN:{"下载中":"ico-stop","下载":"ico-download","继续":"ico-start","安装":"ico-set","更新":"ico-reflash","进入":"ico-open","等待中":"ico-stop"},DEFALUT:true,init:function(){var g=require("Download");g.addListener(g.STATE.ALL,function(){a.showState.apply(a,arguments)})},preventDefault:function(){this.DEFALUT=false},setText:function(n,k,l){var i=this.D_BTN+n,j=require("$"),g=j(i+this.D_TEXT),o=g.attr("isFirst"),m=j(i+this.D_COLOR_BTN),p=j(i+this.D_PRO),h=k;o&&(h=h==this.TEXT.DOWNLOAD?this.TEXT.FIRSTDOWNLOAD:h);g.html(h);p.css("width",l+"%");f&&(g.css("width","58px"),l>0&&(g.hide(),setTimeout(function(){g.show()},0)));k==this.TEXT.START?m.removeClass(this.COLOR_BTN_OTHER).addClass(this.COLOR_BTN_START):m.removeClass(this.COLOR_BTN_START).addClass(this.COLOR_BTN_OTHER)},updateProc:function(h,g,j){var i=parseInt(require("$")(this.D_BTN+h+this.D_TEXT).html())||0;!(i&&g<i)&&this.setText(h,j&&g==0?"下载中":g+"%",g)},_isShowIng:false,_showToast:function(g){!this._isShowIng&&(this._isShowIng=true,require("Api").showMsg(g),setTimeout(function(){a._isShowIng=false},3e3))},showState:function(m,u){if(!this.DEFALUT){return}var n=require("App"),j=require("Download"),g=j.STATE,p=j.PSTATE,i=m.appid,q=m.state,k=m.pro||0,s=parseInt(m.phony_pro)||0,o=j.getProState(i),t=m.ismyapp,h=this,l=null;k=Math.max(k,s);isNaN(k)&&(k=0);var r=function(){var v=p.INSTALL==o,w=require("$")(h.D_BTN+i);if(q!=g.SETUP_END&&w.length<0){return false}switch(q){case g.DOWN:h.updateProc(i,k,t);break;case g.PAUSE:case g.ERROR_DOWN_EXCEPTION:h.setText(i,h.TEXT.CONTINUE,k);break;case g.DOWN_END:case g.SETUP_END:case g.PACKAGE_REPLACE:require("Task").create(l||n.getAppById(i)).map(function(x){if(x&&x.pName){l=x;return{version:n.getAppVersionCode(i,x.pName,x.url),currentDownData:j.query(i,{quite:1,needRet:true})}}else{return{}}}).then(function(y){var B=y.version||{},x=y.currentDownData&&y.currentDownData.length&&y.currentDownData[0]||{},z=parseInt(l.versionCode),A=parseInt(B.installedVersionCode),C=parseInt(B.downloadedVersionCode),D=x&&(x.state==g.DOWN||x.state==g.PAUSE||x.state==g.DOWN_END||x.state==g.WAIT);D?C&&C<z?(h.setText(i,h.TEXT.DOWNLOAD,0),j.overwriteDownData({appid:i,pro:0,state:g.INIT,phony_pro:0})):x.state==g.DOWN_END||x.state==g.SETUP_END||x.state==g.PACKAGE_REPLACE?(h.setText(i,A<z?h.TEXT.INSTALL:h.TEXT.START,100),j.overwriteDownData({appid:i,pro:100,state:A<z?g.DOWN_END:h.TEXT.START,phony_pro:0})):j.overwriteDownData(x):A<z?(h.setText(i,A?h.TEXT.UPDATE:h.TEXT.DOWNLOAD,0),j.overwriteDownData({appid:i,pro:0,state:g.INIT,phony_pro:0}),require("Update").resetUpdateTime4MyappAndUpdateApp(),require("Event").fire("addNewUpdateApp",l),require("AppUpdateData").check(l.pName)):(h.setText(i,h.TEXT.START,0),j.overwriteDownData({appid:i,pro:0,state:g.SETUP_END,phony_pro:0}))}).start();break;case g.UNINSTALL_END:require("Task").create(j.query(i,{quite:1,needRet:true})).then(function(x){x=x&&x.length&&x[0]||{};var y=x&&(x.state==g.DOWN||x.state==g.PAUSE||x.state==g.DOWN_END||x.state==g.WAIT);!y&&h.setText(i,v?h.TEXT.UPDATE:h.TEXT.DOWNLOAD,0)}).start();break;case g.CANCEL:case g.ERROR_SYSTEM:case g.ERROR_SD_UNMOUNT:case g.ERROR_URL_CHANGE:case g.ERROR_NET_ERROR:case g.ERROR_SD_NOSPACE:h.setText(i,v?h.TEXT.UPDATE:h.TEXT.DOWNLOAD,0);break;case g.WAIT:h.setText(i,h.TEXT.WAIT,0);break}};!o?require("Task").create(n.getAppById(i)).then(function(v){l=v;if(v&&v.pName){return n.isInstall(v.pName)}else{this.reject("App is Not exist")}}).then(function(v){o=v?p.INSTALL:p.UNINSTALL;j.updateProState(i,o,true);r()}).start():r()}};a.init();return a});define("PageBtn",function(){var a={refresh:function(b){var c=require("Util"),g=require("Task"),d=require("Page"),e=require("Download"),f=[];c.each(b,function(h){f.push(h.id)});g.create(d.getInstallMap(b)).map(function(h){return{installMap:h,updateMap:d.getUpdateMap(b,h),queryData:e.query(f,{needRet:1,quite:1})}}).then(function(h){var i=require("DownloadBtn"),j=[],l=[],m=[],k=[];c.each(h.queryData,function(n){k.push(n.appid)});c.each(b,function(n){var o=n.id,p=n.pName;-1==k.indexOf(o)&&(h.updateMap[p]?i.setText(o,i.TEXT.UPDATE,0):h.installMap[p]&&i.setText(o,i.TEXT.START,0));h.updateMap[n.pName]&&j.push(n.pName)});e.nativeCallback(h.queryData);require("AppUpdateData").check(j)}).start()}};return a});define("Page",function(){var a={touchTimer:null,dialogShowed:false,_preEvt:function(b){b&&(b.stopPropagation(),b.preventDefault())},detail:function(f,g){var b=g||{};this._preEvt(f);var d=["qapp_center_detail.htm?id="+b.appid],c=require("Channel"),e=require("Via");b.channelId=b.channelId||require("Const").channelId;b.openTime=Date.now();b.channelId==c.HOMESOCIAL&&(b.socialPos=b.rank);[c.TOPIC,c.CATEAPP,c.CATEGAME].indexOf(b.channelId)>=0&&!b.via?b.via=require("Topic").Const.via:[c.HOME_FB,c.HOME_SHB,c.HOME_SB,c.HOME_TB,c.HOME_LB,c.HOME_HB].indexOf(b.channelId)>=0&&(b.via=e.getSourceVia(b.appid,b.channelId));require("Util").each(b,function(h,i){d.push(encodeURIComponent(i)+"="+encodeURIComponent(h))});b.url=d.join("&");require("Task").create(e.getChannelVia(b.channelId)).then(function(h){b.pName&&!/^[234]$/.test(b.tyqtype)?(b.url="sd://"+b.url,b.via=h+(b.via||""),b.myAppId=parseInt(b.myAppId,10)==0?"":b.myAppId,b.apkId=parseInt(b.apkId,10)==0?"":b.apkId,require("Api").goToDetailPage(b)):require("Api").openLocalUrl({url:d.join("&"),titleInfo:[{name:"应用详情",tipNum:0}]})}).start();return false},ad:function(d,e){var b=e||{};this._preEvt(d);b.type=b.type||0;var f={0:"",1:"sd://qapp_center_detail.htm"}[b.type]||"",g={0:"",1:"应用详情"}[b.type];if(b.type==1){var c=f+"?id="+b.adId;c+=(c.indexOf("?")>-1?"&":"?")+"channelId="+b.channelId+"&adId="+b.adId;b.url=c;require("Task").create(require("Via").getChannelVia(b.channelId)).then(function(h){b.via=h;b.appid=b.adId;require("Api").goToDetailPage(b)}).start()}else{b.appurl&&require("Api").openUrl({url:b.appurl,titleInfo:[{name:g||b.title,tipNum:0}]})}require("Task").create(require("Via").getPageVia(b.channelId)).then(function(h){require("Stat").click(h,b.adId)}).start();return false},cate:function(c,b){this._preEvt(c);var d="qapp_center_cate.htm?channelId="+(b||require("Const").channelId)+"&openTime="+Date.now(),e={name:"应用分类",tipNum:0};return require("Api").openLocalUrl({url:d,titleInfo:e});require("Task").create(require("Via").getPageVia(b)).then(function(f){require("Stat").click(f)}).start()},topic:function(b){this._preEvt(b.evt);var c="qapp_center_topic.htm?topicId="+b.topicId+"&channelId="+(b.channelId||require("Const").channelId)+"&key="+b.key+"&via="+(b.via||" ")+"&openTime="+Date.now(),d={name:require("Str").cutRealLen(b.name,20,"…"),tipNum:0};require("LocalStorage").set("tapPageStorageKey",b.key+b.topicId);return require("Api").openLocalUrl({url:c,titleInfo:d,shareData:"&topicId="+b.topicId+"&key="+b.key})},onlineTopic:function(b){this._preEvt(b.evt);var c=b.url;if(b.type=="giftcenter"){var d=require("LocalStorage").get("giftcenterurl");d&&(c=d)}var e={name:require("Str").cutRealLen(b.name,20,"…"),tipNum:0},f={uin:require("Api").get("Uin"),sid:require("Api").get("Sid"),mobileInfo:require("Api").getMobileInfo()};require("Task").create().map(f).then(function(h){var g=[];h.mobileInfo&&(g.push("os_ver="+h.mobileInfo.os_ver),g.push("resolution="+h.mobileInfo.resolution),g.push("os_api_level="+h.mobileInfo.os_api_level),g.push("androidId="+h.mobileInfo.androidID),g.push("imei="+h.mobileInfo.imei),g.push("imsi="+h.mobileInfo.imsi),g.push("macAddress="+h.mobileInfo.wifimac));if(b.param){for(var i in b.param){g.push(i+"="+b.param[i])}}g.push("needPrefix=1");c+=(c.indexOf("?")>=0?"&":"?")+g.join("&");g=[];h.uin&&g.push("uin="+h.uin);h.sid&&g.push("keystr="+encodeURIComponent(h.sid));c+=(c.indexOf("#")>=0?"&":"#")+g.join("&");require("Api").openUrl({url:c,titleInfo:e})}).start();require("Task").create(require("Via").getPageVia(b.channelId)).then(function(g){g=g+(b.viaExtend?b.viaExtend:"");require("Stat").click(g)}).start()},icon:function(d,e){var b=e||{};this._preEvt(d);var c=require("App");b.pName?require("Task").create(c.isInstall(b.pName)).then(function(f){f?c.startApp(b):a.detail(d,b)}).start():c.goWebApp(b);return false},category:function(c,d){var b=d||{};this._preEvt(c);var e="qapp_center_category.htm?type="+b.type+"&channelId="+(b.channelId||require("Const").channelId)+"&openTime="+Date.now(),f={boutique:[{name:"精品",tipNum:0}]},g=f[b.type];return require("Api").openLocalUrl({url:e,current:b.current,titleInfo:g})},rank:function(c,b){this._preEvt(c);require("LocalStorage").set("rank_page_current",b.current);var d="qapp_center_rank.htm?type="+b.type+"&index="+b.current+"&channelId="+(b.channelId||require("Const").channelId)+"&openTime="+Date.now();return require("Api").openLocalUrl({url:d,current:b.current,titleInfo:{name:"软件榜单",tipNum:0}});require("Task").create(require("Via").getPageVia(b.channelId)).then(function(e){require("Stat").click(e)}).start()},info:function(b,c){this._preEvt(b);require("Api").openLocalUrl({url:"qapp_social_apps.html?channelId=10000&openTime="+Date.now(),titleInfo:[{name:"应用消息",tipNum:0}]})},myapp:function(c,d){var b=d||{};this._preEvt(c);require("Api").openLocalUrl({url:"qapp_center_myapp.htm?type="+b.type+"&index="+b.current+"&channelId="+(b.channelId||require("Const").channelId)+"&openTime="+Date.now(),titleInfo:[{name:"我的",tipNum:0}]})},search:function(b,c){var d=c||{};this._preEvt(b);require("Api").openLocalUrl({url:"qapp_center_search.htm?&channelId="+(d.channelId||require("Const").channelId)+"&openTime="+Date.now(),titleInfo:[{name:"搜索",tipNum:0}]})},btn:function(g,h){var b=h||{};this._preEvt(g);var c=require("App"),e=require("Via"),d=require("Task"),i=require("Stat"),f=function(){b.channelId==require("Channel").BOUTIQUE&&d.create(e.getReportVia(b.channelId)).then(function(j){i.send(require("Channel").DETAIL!=require("Const").channelId?"210":"200",j+e.getSourceVia(b.appid,b.channelId),b.appid)}).start()};if(b.pName){require("Notify").combineRequest=false;d.create(require("App").getAppInfo(b.pName)).then(function(j){if(j.length){var k=require("LocalAppFileds");b.isUpdate=true;b.isInstall=true;if(parseInt(b.versionCode)<=parseInt(j[k.versionCode])){c.startApp(b);return}}else{b.isUpdate=false;b.isInstall=false}d.create(require("Download").go(b)).then(function(l){l&&(l=="isInstalled"?c.startApp(b):location.reload())}).start();require("Notify").combineRequest=true;f()}).start();return}else{c.goWebApp(b);f()}return false},update:function(b,c){this.btn(b,c);return false},reportErrMsg:function(c,d,f,g){var b="";c&&(c.stack&&(b=c.stack.split("\n"),b=b.slice(0,5).join("\n")),b=(g||"")+(b||c.message));b&&require("M").stringReport({errMsg:b,code:d,duration:f})},disActive:function(c){var d=require("$"),b=d(this);c.type=="touchmove"&&(clearTimeout(this.touchTimer),b.removeClass("active"),b.unbind("touchmove",a.disActive).unbind("touchend",a.disActive));b.unbind("touchmove",a.disActive).unbind("touchend",a.disActive);window.setTimeout(function(){b.removeClass("active")},200)},bindBtnActiveEvt:function(b,c){require("Util").delegate(b,"touchstart",function(f){var g=require("$"),d=g(this);f.stopPropagation();d.bind("touchmove",a.disActive).bind("touchend",a.disActive);this.touchTimer=setTimeout(function(){d.addClass("active")},100)},c)},getDocWidth:function(){return require("Task").create(require("Api").get("Display")).then(function(b){var c=document.documentElement.clientWidth,b=b.split("x"),d=(b[0]||0)/(devicePixelRatio||1);return c==d?c:d})},unique:function(c){var b=[];require("Util").each(c,function(d){b.indexOf(d)==-1&&b.push(d)});return b},getInstallMap:function(e,d){var f=require("Util"),b=[];d=d||{};var c={};f.each(e,function(g){g&&g.pName&&b.push(g.pName)});b=a.unique(b);if(!b.length){return c}return require("Task").create(require("App").getAppInfo(b)).then(function(j){var g=require("LocalAppFileds"),h={},i={};j.forEach(function(k,l){h[k[g.pName]]=k[g.versionCode];i[k[g.pName]]=k});!!d.allData?c={info:i,installMap:h}:c=h;return c||{}})},getInstallAppids:function(b,c){return require("Task").create(c||this.getInstallMap(b)).then(function(f){var d=[],e=[];require("Util").each(b,function(g){if(g&&g.id){var i=f[g.pName]>=1;i?d.push(g.id):e.push(g.id);var h=require("Download");h.updateProState(g.id,i?h.PSTATE.INSTALL:h.PSTATE.UNINSTALL,true)}});e=a.unique(e);d=a.unique(d);return{appidsNotInstall:e,appidsInstalled:d}})},getUpdateMap:function(b,c){return require("Task").create(c||this.getInstallMap(b)).then(function(d){var e={};require("Util").each(b,function(f){d[f.pName]&&f.versionCode>d[f.pName]&&(e[f.pName]=1)});return e})}};return a});define("Channel",{HOME:"1000",HOME_FB:"1000_1",HOME_SHB:"1000_2",HOME_SB:"1000_3",HOME_TB:"1000_4",HOME_LB:"1000_5",HOME_HB:"1000_6",HOME_NEW:"1000_7",HOME_HOT:"1000_8",HOME_TOPIC:"1000_9",HOMESOCIAL:"3000",HOMEADV:"1003",HOMEADV_BTN:"1003_1",HOMEREC:"2000",SEARCH:"1001",SEARCHRESULT:"1001_1",SEARCH_SINGLE:"1002",SEARCHRESULT_SINGLE:"1002_1",DETAIL:"1006",INDEX_CARD:"1010",GUESS:"1022",GAME:"2100",HOTGAME:"2101",NEWGAME:"2102",GAMEADV:"2103",APPRANK:"2200",APPMAINRANK:"2201",APPPOPRANK:"2202",NOGAMEADV:"2203",MYAPP:"1004",UPDATE:"1011",MYAPPLIST:"2301",MYAPPLIST_NONE:"2301_1",MYAPPLIST_PC:"2301_2",MYAPPLIST_H5:"2301_3",MYAPPLIST_NATIVE:"2301_4",UPDATELIST:"2302",UPDATELIST_NONE:"2302_1",NOTIFICATION:"2400",BOUTIQUEPAGE:"2500",STORE_NEW:"2001",STORE_NORMAL:"2002",PCPUSH_2G3GDIALOG:"2459",_2G3GDIALOG:"2600",OUTSIDE:"2800",FREEGIFT:"1",BRAG:"52",PK:"53",INVITE:"100",PCPUSH_NOTIFY:"56",PCPUSH_AUTO:"57",ASSISTANT:"4000",GDTFEEDS:"10000",TOPIC:"4001",TOPICS:"4002",INDEXTOPICNEC:"5000",INDEXTOPICHOT:"5001",GIFT:"7000",CATE:"6000",CATEAPP:"6001",CATEGAME:"6002",BOUTIQUE:"8000",PRELOADLAYER:"11000"});define("Via",function(){var a=require("Channel"),b={pageVia:{1000:".STORE.HOME","1000_1":".STORE.HOME.FRIENDSAPP","1000_2":".STORE.HOME.FRIENDSSHARE","1000_3":".STORE.HOME.BOYGIRL","1000_4":".STORE.HOME.INTEREST","1000_5":".STORE.HOME.LOCATION","1000_6":".STORE.HOME.FASHION","1000_7":".STORE.HOME.NEW","1000_8":".STORE.HOME.HOT","1000_9":".STORE.HOME.TOPICS.",1010:".STORE.HOME.CARD1",2000:".STORE.HOME.RECOMMEND",3000:".STORE.HOME.SOCIAL",8000:".STORE.HOME.RECOMMEND",10000:".",1001:".STORE.SEARCH","1001_1":".STORE.SEARCH.RESULT",1002:".STORE.SUB.SEARCH","1002_1":".STORE.SUB.SEARCH.RESULT",1003:".STORE.HOME.BANNER","1003_1":".STORE.HOME.BANNERBUTTON",1006:".STORE.APPDETAIL",1022:".STORE.APPDETAIL.GUESSLIST",2100:".STORE.GAMELIST",2101:".STORE.GAMELIST.HOT",2102:".STORE.GAMELIST.NEW",2200:".STORE.APPLIST",2201:".STORE.APP.RANKING",2202:".STORE.APP.POPULAR",1004:".STORE.MYAPP",2301:".STORE.MYAPP.APPLIST","2301_1":".STORE.MYAPP.APPLIST.NOAPP","2301_2":".STORE.MYAPP.APPLIST.PCAPPLIST","2301_3":".STORE.MYAPP.APPLIST.H5APPLIST","2301_4":".STORE.MYAPP.APPLIST.NATIVEAPPLIST",2302:".STORE.MYAPP.UPDATELIST.APPLIST","2302_1":".STORE.MYAPP.UPDATELIST.NOAPP",2410:".STORE.APPDETAIL.MIG",2500:".STORE.BOUTIQUE",2800:".STORE.",2001:".STORE.ASSISTANT.STORE.NEW",2002:".STORE.ASSISTANT.STORE.NORMAL",4001:".STORE.TOPIC.",4002:".STORE.TOPICS.",5000:".STORE.NECESSARY",5001:".STORE.HOTRECOMMEND",5002:".STORE.FIRSTRELEASE",5003:".STORE.GIFTCENTER",7000:".STORE.HOME.GIFTCENTER",6000:".STORE.CATEGORY",6001:".STORE.APP.",6002:".STORE.GAME.",11000:".WIFIDLYYB.STORE"},channelVia:{"1000_1":".STORE.APPDETAIL.HOME.FRIENDSAPP","1000_2":".STORE.APPDETAIL.HOME.FRIENDSSHARE","1000_3":".STORE.APPDETAIL.HOME.BOYGIRL","1000_4":".STORE.APPDETAIL.HOME.INTEREST","1000_5":".STORE.APPDETAIL.HOME.LOCATION","1000_6":".STORE.APPDETAIL.HOME.FASHION","1000_7":".STORE.APPDETAIL.HOME.NEW","1000_8":".STORE.APPDETAIL.HOME.HOT",1010:".STORE.APPDETAIL.HOME.CARD1",1003:".STORE.APPDETAIL.HOME.BANNER","1003_1":".STORE.APPDETAIL.HOME.BANNERBUTTON","1001_1":".STORE.APPDETAIL.SEARCH.RESULT","1002_1":".STORE.APPDETAIL.SUB.SEARCH.RESULT",1004:".STORE.APPDETAIL.MYAPP.APPLIST",1011:".STORE.APPDETAIL.MYAPP.UPDATELIST",1022:".STORE.APPDETAIL.GUESSLIST",2000:".STORE.APPDETAIL.HOME.RECOMMEND",3000:".STORE.APPDETAIL.HOME.SOCIAL.",8000:".STORE.APPDETAIL.HOME.RECOMMEND",2101:".STORE.APPDETAIL.GAMELIST.HOT",2102:".STORE.APPDETAIL.GAMELIST.NEW",2103:".STORE.APPDETAIL.GAMELIST.ADS.",2201:".STORE.APPDETAIL.APP.RANKING",2202:".STORE.APPDETAIL.APP.POPULAR",2203:".STORE.APPDETAIL.APPLIST.ADS.","2301_1":".STORE.APPDETAIL.MYAPP.APPLIST.NOAPP","2301_2":".STORE.APPDETAIL.MYAPP.APPLIST.PCAPPLIST","2301_3":".STORE.APPDETAIL.MYAPP.APPLIST.H5APPLIST","2301_4":".STORE.APPDETAIL.MYAPP.APPLIST.NATIVEAPPLIST","2302_1":".STORE.APPDETAIL.MYAPP.UPDATELIST.NOAPP",2400:".STORE.APPDETAIL.DOWNLOADPUSH",2410:".STORE.APPDETAIL.MIG",2456:".STORE.APPDETAIL.PCPUSH",2457:".STORE.APPDETAIL.PCPUSH.AIOMSG",2458:".STORE.APPDETAIL.PCPUSH.MSGPUSH",2459:".STORE.APPDETAIL.PCPUSH.2G3GDIALOG","2460_1":".FREEGIFT.APPAIO.APPDETAIL","2460_50":".REQUEST.APPAIO.APPDETAIL","2460_52":".BRAG.APPAIO.APPDETAIL","2460_53":".PK.APPAIO.APPDETAIL","2460_100":".INVITE.APPAIO.APPDETAIL",2461:".STORE.APPDETAIL.SHARE-APP",2462:".SHARESOURCE",2500:".STORE.APPDETAIL.BOUTIQUE",2600:".STORE.2G3GDIALOG",2800:".STORE.APPDETAIL.",1:".FREEGIFT.ASSISTANT.APPDETAIL",50:".REQUEST.ASSISTANT.APPDETAIL",52:".BRAG.ASSISTANT.APPDETAIL",53:".PK.ASSISTANT.APPDETAIL",56:".PCPUSH.NOTIFY.ASSISTANT.APPDETAIL",57:".PCPUSH.AUTO.ASSISTANT.APPDETAIL",58:".VOICE.ASSISTANT.APPDETAIL",100:".INVITE.ASSISTANT.APPDETAIL","200_1":".SENDSTORY.FEED1.APPDETAIL","200_2":".SENDSTORY.FEED2.APPDETAIL","100_1":".INSTALL.FEED.APPDETAIL","300_0":".STORE.ASSISTANT.STATEMSG.RECOMMEND.01","300_1":".STORE.ASSISTANT.STATEMSG.RECOMMEND.02","300_2":".STORE.ASSISTANT.STATEMSG.RECOMMEND.03","300_3":".STORE.ASSISTANT.STATEMSG.RECOMMEND.04","300_4":".STORE.ASSISTANT.STATEMSG.RECOMMEND.05","300_5":".STORE.ASSISTANT.STATEMSG.RECOMMEND.06","400_0":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.01","400_1":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.02","400_2":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.03","400_3":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.04","400_4":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.05","400_5":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.06",10000:".",4001:".STORE.APPDETAIL.TOPIC.",4002:".STORE.APPDETAIL.TOPICS.",5000:".STORE.APPDETAIL.NECESSARY",5001:".STORE.APPDETAIL.HOTRECOMMEND",5002:".STORE.APPDETAIL.FIRSTRELEASE",5003:".STORE.APPDETAIL.GIFTCENTER",6001:".STORE.APPDETAIL.APP.",6002:".STORE.APPDETAIL.GAME.",11000:".WIFIDLYYB.STORE.APPDETAIL","-10000":".STORE.APPDETAIL.STARTERROR","-100000":".STORE.APPDETAIL.UNKNOW"},channelExposureVia:{1:".STORE.APPDETAIL.FREEGIFT.ASSISTANT",50:".STORE.APPDETAIL.REQUEST.ASSISTANT",52:".STORE.APPDETAIL.BRAG.ASSISTANT",53:".STORE.APPDETAIL.PK.ASSISTANT",58:".STORE.APPDETAIL.VOICE.ASSISTANT",100:".STORE.APPDETAIL.INVITE.ASSISTANT",10000:".","2460_1":".STORE.APPDETAIL.FREEGIFT.APPAIO","2460_50":".STORE.APPDETAIL.REQUEST.APPAIO","2460_52":".STORE.APPDETAIL.BRAG.APPAIO","2460_53":".STORE.APPDETAIL.PK.APPAIO","2460_100":".STORE.APPDETAIL.INVITE.APPAIO",2456:".STORE.APPDETAIL.PCPUSH",2457:".STORE.APPDETAIL.PCPUSH.AIOMSG",2458:".STORE.APPDETAIL.PCPUSH.MSGPUSH","200_1":".STORE.APPDETAIL.SENDSTORY.FEED1","200_2":".STORE.APPDETAIL.SENDSTORY.FEED2","100_1":".STORE.APPDETAIL.INSTALL.FEED","300_1":".STORE.APPDETAIL.RECOMMEND.01.ASSISTANT","300_2":".STORE.APPDETAIL.RECOMMEND.02.ASSISTANT","300_3":".STORE.APPDETAIL.RECOMMEND.03.ASSISTANT","300_4":".STORE.APPDETAIL.RECOMMEND.04.ASSISTANT","300_5":".STORE.APPDETAIL.RECOMMEND.05.ASSISTANT","300_6":".STORE.APPDETAIL.RECOMMEND.06.ASSISTANT","400_1":".STORE.APPDETAIL.RECOMMEND.01.ASSISTANT","400_2":".STORE.APPDETAIL.RECOMMEND.02.ASSISTANT","400_3":".STORE.APPDETAIL.RECOMMEND.03.ASSISTANT","400_4":".STORE.APPDETAIL.RECOMMEND.04.ASSISTANT","400_5":".STORE.APPDETAIL.RECOMMEND.05.ASSISTANT","400_6":".STORE.APPDETAIL.RECOMMEND.06.ASSISTANT"},moduleVia:[a.HOMESOCIAL,a.HOMEREC,a.SEARCHRESULT,a.BOUTIQUE,a.PRELOADLAYER,a.SEARCHRESULT_SINGLE,a.HOME_FB,a.HOME_SHB,a.HOME_SB,a.HOME_TB,a.HOME_LB,a.HOME_HB,a.HOME_HOT,a.HOME_NEW,a.HOMEADV_BTN,a.OUTSIDE],state:{DOWN:".TODOWNLOAD",INSTALL:".TOINSTALL",UPDATE:".TOUPDATE",AUTOSTART:".TOAUTOSTART",OPEN:".TOOPEN"},getState:function(c){return this.state[c]},setTopicVia:function(){var c={};return function(d,e){!c[d]&&(b.channelVia[d]+=e,b.pageVia[d]+=e,c[d]=1)}}(),setChannelAdId:function(c){this.channelVia["1003"]+=c;this.channelVia["2103"]+=c;this.channelVia["2203"]+=c},setChannelSocialId:function(c){this.channelVia["3000"]+=c},getModuleVia:function(c){c=this.moduleVia.indexOf(c)>=0?c:"";return this.getPageVia(c)},getPageVia:function(c){var d=require("Const");if(a.ASSISTANT==d.channelId){return this.getMsgVia(c)}else{return require("Task").create(require("Api").get("Platform")).then(function(e){return e.toUpperCase()+b.pageVia[c||d.channelId]})}},getChannelVia:function(d,c,e,f){var g=require("Const");return require("Task").create(require("Api").get("Platform")).then(function(h){return h.toUpperCase()+((c?b.channelExposureVia[d||g.channelId]:null)||b.channelVia[d||g.channelId]||b.channelVia["-100000"])+(f?f:"")+(e?e:"")+(c?b.getState(c):"")})},getReportVia:function(c,d){return require("Task").create().map({platform:require("Api").get("Platform"),pageVia:b.getModuleVia(c),channelVia:b.getChannelVia(c),infoVia:b.getMsgVia(c)}).then(function(e){var f=e.pageVia+(c==a.HOMESOCIAL?"."+d:""),g=e.channelVia,h=e.infoVia;return a.DETAIL==require("Const").channelId?g:f!=e.platform.toUpperCase()?f:h})},getMsgChannelVia:function(c){var d={1:".STORE.ASSISTANT.FREEGIFT.PUSH",50:".STORE.ASSISTANT.REQUEST.PUSH",52:".STORE.ASSISTANT.BRAG.PUSH",53:".STORE.ASSISTANT.PK.PUSH",56:".STORE.ASSISTANT.PCPUSH.NOTIFY.PUSH",57:".STORE.ASSISTANT.PCPUSH.AUTO.PUSH",58:".STORE.ASSISTANT.VOICE.PUSH",100:".STORE.ASSISTANT.INVITE.PUSH",2480:".STORE.ASSISTANT.MINIBOX",10000:".STORE.ASSISTANT.MYQZ",3001:".STORE.MSGCARDS"}[c]||"";return require("Task").create(require("Api").get("Platform")).then(function(e){return e.toUpperCase()+d||""})},getMsgVia:function(c){var d={1:".FREEGIFT.ASSISTANT",50:".REQUEST.ASSISTANT",52:".BRAG.ASSISTANT",53:".PK.ASSISTANT",56:".PCPUSH.NOTIFY.ASSISTANT",57:".PCPUSH.AUTO.ASSISTANT",58:".VOICE.ASSISTANT",100:".INVITE.ASSISTANT"}[c]||"";return require("Task").create(require("Api").get("Platform")).then(function(e){return e.toUpperCase()+d||""})},getSourceVia:function(c){return""}};return b});define("MyNotify",function(){var a={};return a});define("CateList",function(){var a={url:"http://mapp.qzone.qq.com/cgi-bin/mapp/mapp_catelist_qq",key:"cateList_",LOADLOCALDATA:true,CACHETIME:1e3*60*60*12,getClassData:function(e,f,g){var d=0,j=e.type,b=this.key+j,c=require("$").parseJSON(require("LocalStorage").get(b));!!c&&f({cateList:c||[]});var h=require("LocalStorage").get(b+"UpdateTime")||0,i=Date.now();d=i>h&&i-h>this.CACHETIME?1:0;!c&&(d=1);d&&require("Http").loadJson({url:this.url,param:e,success:function(k){k&&k.cateList&&k.cateList.length>0?(require("LocalStorage").set(b,require("$").stringify(k.cateList)),require("LocalStorage").set(b+"UpdateTime",Date.now()),f(k)):g(k)},error:function(k){!c&&g(k)}})}};return a});define("ActionBtn",function(){var a={init:function(){var b=/qapp_center_index\.htm/i.test(location.href),c=/qapp_center_search\.htm/i.test(location.href);require("Api").setActionButton({iconType:b?"0":"1",callBackKey:b?"":"onGoToSearch",visible:c?"0":"1"});this.bind()},bind:function(){var b=null,c=function(){};require("Event").on("onGoToSearch",function(){!b&&(b=true,require("Page").search(),setTimeout(function(){b=false},500))})}};a.init();return a});define("PreDwonloadYYB",function(){var a={isInit:false,DEFAULIMITTIME:1296e6,layer:null,flagInstall:false,flagLayerHide:false,flagLayerExposured:false,initLayer:function(){if(!this.layer){var b=document.createElement("div");b.innerHTML=a.tmpl.layer();require("$")("body").append(b.querySelector("#preDownloadLayer"));this.layer=require("$")("#preDownloadLayer")}},downloadCallBack:function(d){var c=require("Download"),e=c.STATE,b=this;if(c.YYBAPPID==d.appid||c.YYBPNAME==d.packagename){switch(d.state){case e.DOWN:d.download_from==1?(this.layer.addClass("single").show().find(".preDownloadLayer-content").html("应用中心升级中"),this.flagInstall=false,this.flagLayerHide=false,require("LocalStorage").set("preDownloadLayerClose","0")):(this.layer.hide(),this.flagLayerExposured=false);break;case e.DOWN_END:if(d.download_from==1){var f=require("LocalStorage"),g=parseInt(f.get("preload_layer")),h=!isNaN(g)?g:b.DEFAULIMITTIME,i=parseInt(f.get("preDownloadLayerClose"))||0;require("Task").create(require("App").getAppVersionCode("1101070898","com.tencent.android.qqdownloader","")).then(function(j){var k=parseInt(j.installedVersionCode),l=parseInt(j.downloadedVersionCode);Date.now()-i>h&&(!b.flagLayerHide&&(!k||k<106e4)&&(b.layer.removeClass("single").show().find(".preDownloadLayer-content").html("一键开启应用中心专属高速下载器[应用宝]，下载速度提升20%"),!b.flagLayerExposured&&require("Task").create(require("Via").getReportVia(require("Channel").PRELOADLAYER)).then(function(m){require("Stat").exposure(m,c.YYBAPPID)}).start(),b.flagLayerExposured=true),b.flagInstall=true)}).start()}else{this.layer.hide();this.flagLayerExposured=false}break;case e.SETUP_END:case e.PACKAGE_REPLACE:require("Task").create(require("App").getAppInfo(c.YYBPNAME)).then(function(j){var k=j&&j[1]||0;k>=106e4?(b.layer.hide(),this.flagLayerExposured=false):!b.flagLayerHide&&(b.layer.show(),!b.flagLayerExposured&&require("Task").create(require("Via").getReportVia(require("Channel").PRELOADLAYER)).then(function(l){require("Stat").exposure(l,c.YYBAPPID)}).start(),b.flagLayerExposured=true)}).start();break;default:this.layer.hide();this.flagInstall=false;this.flagLayerExposured=false;break}}},bind:function(){var b=this,c=require("Download");c.addListener(c.STATE.ALL,function(d,e){b.downloadCallBack(d)});this.layer.bind("click",function(d){b.flagInstall&&(c.go({appid:c.YYBAPPID,myAppId:0,versionCode:0,url:"",pName:c.YYBPNAME,appName:"应用宝",channelId:require("Channel").PRELOADLAYER,overWriteState:c.STATE.DOWN_END,focus:1}).start(),b.layer.hide(),b.flagLayerHide=true,this.flagLayerExposured=false,require("Task").create(require("Via").getReportVia(require("Channel").PRELOADLAYER)).then(function(e){require("Stat").click(e,c.YYBAPPID)}).start())});this.layer.find("span").bind("click",function(d){d.preventDefault();d.stopPropagation();b.layer.hide();this.flagLayerExposured=false;require("LocalStorage").set("preDownloadLayerClose",Date.now())});require("Event").on("resume",function(){var d=require("LocalStorage"),e=parseInt(d.get("preload_layer")),f=!isNaN(e)?e:b.DEFAULIMITTIME,g=parseInt(d.get("preDownloadLayerClose"))||0;Date.now()-g<f&&(b.layer.hide(),this.flagLayerExposured=false)})},init:function(){if(this.isInit){return}var d=navigator.userAgent,b=/QQ\/([\d.]+)/.exec(d),e="5.1";b&&(b=b[1]);if(!require("Util").greaterThanOrEqual(b,e)){return}this.initLayer();this.bind();setTimeout(function(){require("Task").create(require("Via").getReportVia(require("Channel").PRELOADLAYER)).then(function(f){require("Notify").pull(require("Config").download,"doWifiDownloadAction",{via:f}).start()}).start()},2e3);var c=require("Download");c.query({id:c.YYBAPPID,pName:c.YYBPNAME},{focus:true});this.isInit=true}};a.tmpl={};a.tmpl.layer=function(c){with(c||{}){var b=[];b.push('<div id="preDownloadLayer" class="preDownloadLayer"><span></span><div class="preDownloadLayer-container"><div class="preDownloadLayer-content"><p>应用中心升级中</p></div></div><a href="javascript:void(0);">一键开启</a></div>');return b.join("")}};a.init();return a});
